<?php
/*
 * Add-on Name: Advantage Block Module
 */
if ( ! class_exists( 'St_Advantage_Block_Module' ) ) {
	class St_Advantage_Block_Module {
		function __construct() {
			add_shortcode( 'st_advantage_block_module', array( $this, 'advantage_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'advantage_block_module_init' ) );
		}

		function advantage_block_module_shortcode( $atts, $content ) {
			$output      = $first_image = $second_image = $third_image = $fourth_image = $first_number = $second_number = $third_number = $fourth_number = $first_title = $first_description = $second_title = $second_description = $third_title = $third_description = $fourth_title = $fourth_description = '';
			$number_font = $number_font_color = $number_font_style = $number_font_size = $number_line_height = $number_letter_spacing = '';
			$title_font  = $title_font_color = $title_font_style = $title_font_size = $title_line_height = $title_letter_spacing = '';
			$desc_font   = $desc_font_color = $desc_font_style = $desc_font_size = $desc_line_height = $desc_letter_spacing = '';
			$el_class    = $module_animation = $animation = $animated = '';

			extract( shortcode_atts( array(
				'first_image'           => '',
				'second_image'          => '',
				'third_image'           => '',
				'fourth_image'          => '',
				'first_number'          => '',
				'first_title'           => '',
				'first_description'     => '',
				'second_number'         => '',
				'second_title'          => '',
				'second_description'    => '',
				'third_number'          => '',
				'third_title'           => '',
				'third_description'     => '',
				'fourth_number'         => '',
				'fourth_title'          => '',
				'fourth_description'    => '',
				'number_font'           => '',
				'number_font_style'     => '',
				'number_font_size'      => '',
				'number_font_color'     => '',
				'number_line_height'    => '',
				'number_letter_spacing' => '',
				'title_font'            => '',
				'title_font_style'      => '',
				'title_font_size'       => '',
				'title_font_color'      => '',
				'title_line_height'     => '',
				'title_letter_spacing'  => '',
				'desc_font'             => '',
				'desc_font_style'       => '',
				'desc_font_size'        => '',
				'desc_font_color'       => '',
				'desc_line_height'      => '',
				'desc_letter_spacing'   => '',
				'module_animation'      => '',
				'el_class'              => '',
			), $atts ) );

			$id = uniqid( 'st-advantage-block-' );

			$first_image_src  = wp_get_attachment_image_src( $first_image, 'full' );
			$first_image_link = $first_image_src[0];
			$first_bg         = ' style="background-image:url(' . esc_url( $first_image_link ) . ')"';

			$second_image_src  = wp_get_attachment_image_src( $second_image, 'full' );
			$second_image_link = $second_image_src[0];
			$second_bg         = ' style="background-image:url(' . esc_url( $second_image_link ) . ')"';

			$third_image_src  = wp_get_attachment_image_src( $third_image, 'full' );
			$third_image_link = $third_image_src[0];
			$third_bg         = ' style="background-image:url(' . esc_url( $third_image_link ) . ')"';

			$fourth_image_src  = wp_get_attachment_image_src( $fourth_image, 'full' );
			$fourth_image_link = $fourth_image_src[0];
			$fourth_bg         = ' style="background-image:url(' . esc_url( $fourth_image_link ) . ')"';

			// Number
			$number_style = ' style="';

			if ( $number_font !== '' ) {
				$number_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $number_font ) : '';
				if ( $number_font_family !== '' ) {
					$number_style .= ! empty( $number_font_family ) ? 'font-family:\'' . $number_font_family . '\';' : '';
				}
			}

			if ( $number_font_style !== '' ) {
				$number_style .= esc_attr( $number_font_style );
			}

			if ( is_numeric( $number_font_size ) ) {
				$number_font_size = 'desktop:' . $number_font_size . 'px;';
			}

			if ( is_numeric( $number_line_height ) ) {
				$number_line_height = 'desktop:' . $number_line_height . 'px;';
			}

			$number_args = array(
				'target'      => "#" . $id . " .st-advantage-block-number",
				'media_sizes' => array(
					'font-size'   => $number_font_size,
					'line-height' => $number_line_height,
				),
			);

			$number_responsive = get_ultimate_vc_responsive_media_css( $number_args );

			$number_style .= $number_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $number_letter_spacing ) . 'px;' : '';
			$number_style .= $number_font_color !== '' ? 'color:' . esc_attr( $number_font_color ) . ';' : '';
			$number_style .= '"';

			// Title
			$title_style = ' style="';

			if ( $title_font !== '' ) {
				$title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $title_font ) : '';
				if ( $title_font_family !== '' ) {
					$title_style .= ! empty( $title_font_family ) ? 'font-family:\'' . $title_font_family . '\';' : '';
				}
			}

			if ( $title_font_style !== '' ) {
				$title_style .= esc_attr( $title_font_style );
			}

			if ( is_numeric( $title_font_size ) ) {
				$title_font_size = 'desktop:' . $title_font_size . 'px;';
			}

			if ( is_numeric( $title_line_height ) ) {
				$title_line_height = 'desktop:' . $title_line_height . 'px;';
			}

			$title_args = array(
				'target'      => "#" . $id . " .st-advantage-block-title",
				'media_sizes' => array(
					'font-size'   => $title_font_size,
					'line-height' => $title_line_height,
				),
			);

			$title_responsive = get_ultimate_vc_responsive_media_css( $title_args );

			$title_style .= $title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $title_letter_spacing ) . 'px;' : '';
			$title_style .= $title_font_color !== '' ? 'color:' . esc_attr( $title_font_color ) . ';' : '';
			$title_style .= '"';

			// Description
			$desc_style = ' style="';

			if ( $desc_font !== '' ) {
				$desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $desc_font ) : '';
				$desc_style       .= ! empty( $desc_font_family ) ? 'font-family:\'' . $desc_font_family . '\';' : '';
			}

			if ( $desc_font_style !== '' ) {
				$desc_style .= esc_attr( $desc_font_style );
			}

			if ( is_numeric( $desc_font_size ) ) {
				$desc_font_size = 'desktop:' . $desc_font_size . 'px;';
			}

			if ( is_numeric( $desc_line_height ) ) {
				$desc_line_height = 'desktop:' . $desc_line_height . 'px;';
			}

			$desc_args = array(
				'target'      => "#" . $id . " .st-advantage-block-desc",
				'media_sizes' => array(
					'font-size'   => $desc_font_size,
					'line-height' => $desc_line_height,
				),
			);

			$desc_responsive = get_ultimate_vc_responsive_media_css( $desc_args );

			$desc_style .= $desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $desc_letter_spacing ) . 'px;' : '';
			$desc_style .= $desc_font_color !== '' ? 'color:' . esc_attr( $desc_font_color ) . ';' : '';
			$desc_style .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			if ( ! empty( $third_title ) && empty( $fourth_title ) ) {
				$el_class .= ' three';
			} elseif ( ! empty( $fourth_title ) ) {
				$el_class .= ' four';
			}

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$output .= '<div class="st-advantage-block ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . ' id="' . esc_attr( $id ) . '">';
			if ( ! empty( $first_title ) ) {
				$output .= '<div class="st-advantage-block-first hover"' . $first_bg . '><div class="st-advantage-block-overlay"></div>';
				$output .= '<div class="st-advantage-block-number ult-responsive active" ' . $number_style . ' ' . $number_responsive . '>' . esc_attr( $first_number ) . '</div>';
				$output .= '<div class="st-advantage-block-title ult-responsive active" ' . $title_style . ' ' . $title_responsive . '>' . esc_attr( $first_title ) . '</div>';
				$output .= '<div class="st-advantage-block-desc ult-responsive active" ' . $desc_style . ' ' . $desc_responsive . '>' . wp_kses_post( $first_description ) . '</div>';
				$output .= '</div>'; // st-advantage-block-first
			}
			if ( ! empty( $second_title ) ) {
				$output .= '<div class="st-advantage-block-second"' . $second_bg . '><div class="st-advantage-block-overlay"></div>';
				$output .= '<div class="st-advantage-block-number ult-responsive" ' . $number_style . ' ' . $number_responsive . '>' . esc_attr( $second_number ) . '</div>';
				$output .= '<div class="st-advantage-block-title ult-responsive" ' . $title_style . ' ' . $title_responsive . '>' . esc_attr( $second_title ) . '</div>';
				$output .= '<div class="st-advantage-block-desc ult-responsive" ' . $desc_style . ' ' . $desc_responsive . '>' . wp_kses_post( $second_description ) . '</div>';
				$output .= '</div>'; // st-advantage-block-second
			}
			if ( ! empty( $third_title ) ) {
				$output .= '<div class="st-advantage-block-third"' . $third_bg . '><div class="st-advantage-block-overlay"></div>';
				$output .= '<div class="st-advantage-block-number ult-responsive" ' . $number_style . ' ' . $number_responsive . '>' . esc_attr( $third_number ) . '</div>';
				$output .= '<div class="st-advantage-block-title ult-responsive" ' . $title_style . ' ' . $title_responsive . '>' . esc_attr( $third_title ) . '</div>';
				$output .= '<div class="st-advantage-block-desc ult-responsive" ' . $desc_style . ' ' . $desc_responsive . '>' . wp_kses_post( $third_description ) . '</div>';
				$output .= '</div>'; // st-advantage-block-third
			}
			if ( ! empty( $fourth_title ) ) {
				$output .= '<div class="st-advantage-block-fourth"' . $fourth_bg . '><div class="st-advantage-block-overlay"></div>';
				$output .= '<div class="st-advantage-block-number ult-responsive" ' . $number_style . ' ' . $number_responsive . '>' . esc_attr( $fourth_number ) . '</div>';
				$output .= '<div class="st-advantage-block-title ult-responsive" ' . $title_style . ' ' . $title_responsive . '>' . esc_attr( $fourth_title ) . '</div>';
				$output .= '<div class="st-advantage-block-desc ult-responsive" ' . $desc_style . ' ' . $desc_responsive . '>' . wp_kses_post( $fourth_description ) . '</div>';
				$output .= '</div>'; // st-advantage-block-third
			}
			$output .= '</div>'; // st-advantage-block

			return $output;
		}

		function advantage_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'                    => __( 'Advantage Block', 'adamas-vc-shortcodes' ),
					'base'                    => 'st_advantage_block_module',
					'category'                => esc_html__( 'ST Addons', 'adamas-vc-shortcodes' ),
					'icon'                    => get_template_directory_uri() . '/assets/images/shortcode_icons/advantage_block.png',
					'show_settings_on_create' => true,
					'params'                  => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'First background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'first_image',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'First block number', 'adamas-vc-shortcodes' ),
							'param_name'  => 'first_number',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'First block title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'first_title',
							'description' => ''
						),
						array(
							'type'        => 'textarea',
							'heading'     => __( 'First block description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'first_description',
							'description' => ''
						),
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Second background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'second_image',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Second block number', 'adamas-vc-shortcodes' ),
							'param_name'  => 'second_number',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Second block title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'second_title',
							'description' => ''
						),
						array(
							'type'        => 'textarea',
							'heading'     => __( 'Second block description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'second_description',
							'description' => ''
						),
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Third background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'third_image',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Third block number', 'adamas-vc-shortcodes' ),
							'param_name'  => 'third_number',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Third block title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'third_title',
							'description' => ''
						),
						array(
							'type'        => 'textarea',
							'heading'     => __( 'Third block description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'third_description',
							'description' => ''
						),
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Fourth background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'fourth_image',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Fourth block number', 'adamas-vc-shortcodes' ),
							'param_name'  => 'fourth_number',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Fourth block title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'fourth_title',
							'description' => ''
						),
						array(
							'type'        => 'textarea',
							'heading'     => __( 'Fourth block description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'fourth_description',
							'description' => ''
						),

						// Number typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Number font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'number_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Number font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'number_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Number font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'number_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Number font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'number_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Number line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'number_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Number letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'number_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'title_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'desc_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'desc_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_advantage_block_module = new St_Advantage_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_advantage_block_module extends WPBakeryShortCode {
		}
	}
}