<?php
/*
 * Add-on Name: Testimonials Module
 */
if ( ! class_exists( 'St_Testimonials_Module' ) ) {
	class St_Testimonials_Module {
		function __construct() {
			add_shortcode( 'st_testimonials_module', array( $this, 'testimonials_module_shortcode' ) );
			add_action( 'init', array( $this, 'testimonials_module_init' ) );
		}

		function testimonials_module_shortcode( $atts ) {
			$testimonial_layout     = $testimonials = '';
			$client_img             = $client_name_font = $client_name_font_style = $client_name_color = $client_name_font_size = $client_name_line_height = $client_name_letter_spacing = '';
			$client_occupation_font = $client_occupation_font_style = $client_occupation_color = $client_occupation_font_size = $client_occupation_line_height = $client_occupation_letter_spacing = '';
			$client_company_font    = $client_company_font_style = $client_company_color = $client_company_font_size = $client_company_line_height = $client_company_letter_spacing = '';
			$client_comment_font    = $client_comment_font_style = $client_comment_color = $client_comment_font_size = $client_comment_line_height = $client_comment_letter_spacing = '';
			$el_class               = $module_animation = $animation = $animated = '';

			extract( shortcode_atts( array(
				'testimonial_layout'               => '',
				'testimonials'                     => '',
				'client_name_font'                 => '',
				'client_name_font_style'           => '',
				'client_name_color'                => '',
				'client_name_font_size'            => '',
				'client_name_line_height'          => '',
				'client_name_letter_spacing'       => '',
				'client_occupation_font'           => '',
				'client_occupation_font_style'     => '',
				'client_occupation_color'          => '',
				'client_occupation_font_size'      => '',
				'client_occupation_line_height'    => '',
				'client_occupation_letter_spacing' => '',
				'client_company_font'              => '',
				'client_company_font_style'        => '',
				'client_company_color'             => '',
				'client_company_font_size'         => '',
				'client_company_line_height'       => '',
				'client_company_letter_spacing'    => '',
				'client_comment_font'              => '',
				'client_comment_font_style'        => '',
				'client_comment_color'             => '',
				'client_comment_font_size'         => '',
				'client_comment_line_height'       => '',
				'client_comment_letter_spacing'    => '',
				'module_animation'                 => '',
				'el_class'                         => '',
			), $atts ) );

			$company_logo_count = 0;
			$output             = '';

			$id = uniqid( 'st-testimonials-' );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			if ( empty( $testimonial_layout ) ) {
				$testimonial_layout = 'style-1';
			}

			// Client name
			$client_name_style = 'style="';

			if ( $client_name_font !== '' ) {
				$client_name_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $client_name_font ) : '';
				if ( $client_name_font_family !== '' ) {
					$client_name_style .= 'font-family:\'' . $client_name_font_family . '\';';
				}
			}

			if ( $client_name_font_style !== '' ) {
				$client_name_style .= esc_attr( $client_name_font_style );
			}

			if ( is_numeric( $client_name_font_size ) ) {
				$client_name_font_size = 'desktop:' . $client_name_font_size . 'px;';
			}

			if ( is_numeric( $client_name_line_height ) ) {
				$client_name_line_height = 'desktop:' . $client_name_line_height . 'px;';
			}

			$client_name_args = array(
				'target'      => "#" . $id . " .st-testimonial-client-name",
				'media_sizes' => array(
					'font-size'   => $client_name_font_size,
					'line-height' => $client_name_line_height,
				),
			);

			$client_name_responsive = get_ultimate_vc_responsive_media_css( $client_name_args );

			$client_name_style .= $client_name_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $client_name_letter_spacing ) . 'px;' : '';
			$client_name_style .= $client_name_color !== '' ? 'color:' . esc_attr( $client_name_color ) . ';' : '';
			$client_name_style .= '"';

			// Client occupation
			$client_occupation_style = 'style="';

			if ( $client_occupation_font !== '' ) {
				$client_occupation_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $client_occupation_font ) : '';
				$client_occupation_style       .= ! empty( $client_occupation_font_family ) ? 'font-family:\'' . $client_occupation_font_family . '\';' : '';
			}
			if ( $client_occupation_font_style !== '' ) {
				$client_occupation_style .= esc_attr( $client_occupation_font_style );
			}

			if ( is_numeric( $client_occupation_font_size ) ) {
				$client_occupation_font_size = 'desktop:' . $client_occupation_font_size . 'px;';
			}
			if ( is_numeric( $client_occupation_line_height ) ) {
				$client_occupation_line_height = 'desktop:' . $client_occupation_line_height . 'px;';
			}

			$client_occupation_args = array(
				'target'      => '#' . $id . ' .st-testimonial-client-occupation',
				'media_sizes' => array(
					'font-size'   => $client_occupation_font_size,
					'line-height' => $client_occupation_line_height,
				),
			);

			$client_occupation_responsive = get_ultimate_vc_responsive_media_css( $client_occupation_args );
			$client_occupation_style      .= $client_occupation_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $client_occupation_letter_spacing ) . 'px;' : '';
			$client_occupation_style      .= $client_occupation_color !== '' ? 'color:' . esc_attr( $client_occupation_color ) . ';' : '';
			$client_occupation_style      .= '"';

			// Client company
			$client_company_style = 'style="';

			if ( $client_company_font !== '' ) {
				$client_company_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $client_company_font ) : '';
				$client_company_style       .= ! empty( $client_company_font_family ) ? 'font-family:\'' . $client_company_font_family . '\';' : '';
			}
			if ( $client_company_font_style !== '' ) {
				$client_company_style .= esc_attr( $client_company_font_style );
			}

			if ( is_numeric( $client_company_font_size ) ) {
				$client_company_font_size = 'desktop: ' . $client_company_font_size . 'px;';
			}
			if ( is_numeric( $client_company_line_height ) ) {
				$client_company_line_height = 'desktop: ' . $client_company_line_height . 'px;';
			}

			$client_company_args = array(
				'target'      => '#' . $id . ' .st-testimonial-client-company',
				'media_sizes' => array(
					'font-size'   => $client_company_font_size,
					'line-height' => $client_company_line_height,
				),
			);

			$client_company_responsive = get_ultimate_vc_responsive_media_css( $client_company_args );
			$client_company_style      .= $client_company_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $client_company_letter_spacing ) . 'px;' : '';
			$client_company_style      .= $client_company_color !== '' ? 'color:' . esc_attr( $client_company_color ) . ';' : '';
			$client_company_style      .= '"';

			// Client comment
			$client_comment_style = 'style="';

			if ( $client_comment_font !== '' ) {
				$client_comment_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $client_comment_font ) : '';
				$client_comment_style       .= ! empty( $client_comment_font_family ) ? 'font-family:\'' . $client_comment_font_family . '\';' : '';
			}
			if ( $client_comment_font_style !== '' ) {
				$client_comment_style .= esc_attr( $client_comment_font_style );
			}

			if ( is_numeric( $client_comment_font_size ) ) {
				$client_comment_font_size = 'desktop: ' . $client_comment_font_size . 'px;';
			}
			if ( is_numeric( $client_comment_line_height ) ) {
				$client_comment_line_height = 'desktop: ' . $client_comment_line_height . 'px;';
			}

			$client_comment_args = array(
				'target'      => '#' . $id . ' .st-testimonial-client-comment',
				'media_sizes' => array(
					'font-size'   => $client_comment_font_size,
					'line-height' => $client_comment_line_height,
				),
			);

			$client_comment_responsive = get_ultimate_vc_responsive_media_css( $client_comment_args );
			$client_comment_style      .= $client_comment_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $client_comment_letter_spacing ) . 'px;' : '';
			$client_comment_style      .= $client_comment_color !== '' ? 'color:' . esc_attr( $client_comment_color ) . ';' : '';
			$client_comment_style      .= '"';

			$testimonials_array = preg_split( '/[\s,]+/', $testimonials );
			$args               = array(
				'post_type'   => 'testimonials',
				'post_status' => 'publish',
				'post__in'    => $testimonials_array,
			);

			$testimonials_query = new WP_Query( $args );

			$output .= '<div class="st-testimonials-wrapper ' . esc_attr( $testimonial_layout ) . '">';
			if ( $testimonial_layout == 'style-1' ) {
				$output .= '<div id="' . esc_attr( $id ) . '" class="st-testimonials-slider ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
				while ( $testimonials_query->have_posts() ) : $testimonials_query->the_post();
					$output .= '<div class="st-testimonial-item">';
					if ( has_post_thumbnail() ) {
						$image_id  = get_post_thumbnail_id();
						$image_url = wp_get_attachment_url( $image_id, 'full' );
						$img_bg    = 'background-image:url(' . esc_url( $image_url ) . ')';
						$output    .= '<div class="st-testimonial-client-photo" style="' . $img_bg . '"></div>';
					}
					$output            .= '<div class="st-testimonial-item-inner-wrapper">';
					$output            .= '<div class="st-testimonial-client">';
					$output            .= '<div class="st-testimonial-client-name ult-responsive" ' . $client_name_style . ' ' . $client_name_responsive . '>' . esc_attr( get_the_title() ) . '</div>';
					$client_occupation = get_post_meta( get_the_ID(), 'st_testimonials_position', true );
					if ( ! empty( $client_occupation ) ) {
						$output .= '<div class="st-testimonial-client-occupation ult-responsive" ' . $client_occupation_style . ' ' . $client_occupation_responsive . '>' . esc_attr( $client_occupation ) . ',</div>';
					}
					$client_company = get_post_meta( get_the_ID(), 'st_testimonials_company_name', true );
					if ( ! empty( $client_company ) ) {
						$output .= '<div class="st-testimonial-client-company ult-responsive" ' . $client_company_style . ' ' . $client_company_responsive . '>' . esc_attr( $client_company ) . '</div>';
					}
					$output .= '</div>'; // st-testimonial-client
					$output .= '<div class="st-testimonial-client-comment ult-responsive" ' . $client_comment_style . ' ' . $client_comment_responsive . '>' . wp_kses_post( get_the_content() ) . '</div>';
					$output .= '</div>'; // st-testimonial-item-inner-wrapper
					$output .= '</div>'; // st-testimonial-item	
				endwhile;
				wp_reset_postdata();
			} elseif ( $testimonial_layout == 'style-2' ) {
				$output .= '<div id="' . esc_attr( $id ) . '" class="st-testimonials-slider ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
				while ( $testimonials_query->have_posts() ) : $testimonials_query->the_post();
					$company_img      = get_post_meta( get_the_ID(), 'st_testimonials_company_logo_id', true );
					$company_img_link = wp_get_attachment_url( $company_img );
					$company_img_alt  = get_post_meta( $company_img, '_wp_attachment_image_alt', true );
					if ( ! empty( $company_img_link ) ) {
						$item_class = ' with-company-logo';
					} else {
						$item_class = '';
					}

					$output            .= '<div class="st-testimonial-item ' . $item_class . '">';
					$output            .= '<div class="st-testimonial-client">';
					$output            .= '<div class="st-testimonial-client-name ult-responsive" ' . $client_name_style . ' ' . $client_name_responsive . '>' . esc_attr( get_the_title() ) . '</div>';
					$client_occupation = get_post_meta( get_the_ID(), 'st_testimonials_position', true );
					if ( ! empty( $client_occupation ) ) {
						$output .= '<div class="st-testimonial-client-occupation ult-responsive" ' . $client_occupation_style . ' ' . $client_occupation_responsive . '>' . esc_attr( $client_occupation ) . '</div>';
					}
					$client_company = get_post_meta( get_the_ID(), 'st_testimonials_company_name', true );
					if ( ! empty( $client_company ) ) {
						$output .= '<div class="st-testimonial-client-company ult-responsive" ' . $client_company_style . ' ' . $client_company_responsive . '>' . esc_attr( $client_company ) . '</div>';
					}
					$output .= '</div>'; // st-testimonial-client
					if ( ! empty( $company_img_link ) ) {
						$output .= '<div class="st-testimonial-company-logo"><img src="' . esc_url( $company_img_link ) . '" alt="' . esc_attr( $company_img_alt ) . '"></div>';
					}
					if ( has_post_thumbnail() ) {
						$image_id  = get_post_thumbnail_id();
						$image_url = wp_get_attachment_url( $image_id, 'full' );
						$img_bg    = 'background-image:url(' . esc_url( $image_url ) . ')';
						$output    .= '<div class="st-testimonial-client-photo-wrapper"><div class="st-testimonial-client-photo" style="' . $img_bg . '"></div></div>';
					}
					$output .= '<div class="st-testimonial-client-comment ult-responsive" ' . $client_comment_style . ' ' . $client_comment_responsive . '>' . wp_kses_post( get_the_content() ) . '</div>';
					$output .= '</div>'; // st-testimonial-item
				endwhile;
				wp_reset_postdata();
			} else {
				$output .= '<div id="' . esc_attr( $id ) . '" class="st-testimonials-slider ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
				while ( $testimonials_query->have_posts() ) : $testimonials_query->the_post();
					$output .= '<div class="st-testimonial-item">';
					if ( has_post_thumbnail() ) {
						$image_id  = get_post_thumbnail_id();
						$image_url = wp_get_attachment_url( $image_id, 'full' );
						$img_bg    = 'background-image:url(' . esc_url( $image_url ) . ')';
						$output    .= '<div class="st-testimonial-client-photo-wrapper"><div class="st-testimonial-client-photo" style="' . $img_bg . '"></div></div>';
					}
					$output            .= '<div class="st-testimonial-client-comment ult-responsive" ' . $client_comment_style . ' ' . $client_comment_responsive . '>' . wp_kses_post( get_the_content() ) . '</div>';
					$output            .= '<div class="st-testimonial-client">';
					$output            .= '<div class="st-testimonial-client-name ult-responsive" ' . $client_name_style . ' ' . $client_name_responsive . '>' . esc_attr( get_the_title() ) . '</div>';
					$client_occupation = get_post_meta( get_the_ID(), 'st_testimonials_position', true );
					if ( ! empty( $client_occupation ) ) {
						$output .= '<div class="st-testimonial-client-occupation ult-responsive" ' . $client_occupation_style . ' ' . $client_occupation_responsive . '>' . esc_attr( $client_occupation ) . '</div>';
					}
					$client_company = get_post_meta( get_the_ID(), 'st_testimonials_company_name', true );
					if ( ! empty( $client_company ) ) {
						$output .= '<div class="st-testimonial-client-company ult-responsive" ' . $client_company_style . ' ' . $client_company_responsive . '>' . esc_attr( $client_company ) . '</div>';
					}
					$output .= '</div>'; // st-testimonial-client
					$output .= '</div>'; // st-testimonial-item
				endwhile;
				wp_reset_postdata();
			}
			$output .= '</div>'; // st-testimonials-slider
			if ( $testimonial_layout == 'style-1' ) {
				$output .= '<div id="' . esc_attr( $id ) . '-logos" class="st-testimonials-logo-slider">';
				while ( $testimonials_query->have_posts() ) : $testimonials_query->the_post();
					$company_logo_count ++;
					$company_img      = get_post_meta( get_the_ID(), 'st_testimonials_company_logo_id', true );
					$company_img_link = wp_get_attachment_url( $company_img );
					$company_img_alt  = get_post_meta( $company_img, '_wp_attachment_image_alt', true );
					$output           .= '<div class="st-testimonial-company-logo"><img src="' . esc_url( $company_img_link ) . '" alt="' . esc_attr( $company_img_alt ) . '"></div>';
				endwhile;
				wp_reset_postdata();
				$output .= '</div>'; // st-testimonials-logo-slider
			}
			$output .= '</div>'; // st-testimonials-wrapper

			wp_enqueue_script( 'slick' );

			$rtl = '';
			if ( is_rtl() ) {
				$rtl = 'rtl:true';
			}

			$output .= '<script type="text/javascript">';
			$output .= '(function($){';
			$output .= '"use strict";';
			if ( $testimonial_layout == 'style-1' ) {
				if ( $company_logo_count == 1 || $company_logo_count == 2 ) {
					$output .= '$("head").append("<style>.st-testimonials-wrapper .st-testimonials-logo-slider .slick-list{width:160px !important;overflow:hidden !important}</style>");';
				} else if ( $company_logo_count == 3 || $company_logo_count == 4 ) {
					$output .= '$("head").append("<style>.st-testimonials-wrapper .st-testimonials-logo-slider .slick-list{width:500px !important;overflow:hidden !important}</style>");';
				}
			}
			$output .= '$(document).ready(function(){';
			if ( $testimonial_layout == 'style-1' ) {
				$output .= '$("#' . esc_js( $id ) . '").slick({rows:0,slidesToShow:1,slidesToScroll:1,arrows:false,swipeToSlide:false,asNavFor:"#' . esc_js( $id ) . '-logos",' . esc_js( $rtl ) . '});$("#' . esc_js( $id ) . '-logos").slick({slidesToShow:1,slidesToScroll:1,asNavFor: "#' . esc_js( $id ) . '",swipeToSlide:true,centerMode:true,focusOnSelect:true,variableWidth:true,responsive:[{breakpoint:767,settings:{slidesToShow:1}}],' . esc_js( $rtl ) . '});';
			} else {
				$output .= '$("#' . esc_js( $id ) . '").slick({rows:0,slidesToShow:1,slidesToScroll:1,swipeToSlide:false,arrows:false,dots:true,' . esc_js( $rtl ) . '});';
			}
			$output .= '});';
			$output .= '})(jQuery);';
			$output .= '</script>';

			return $output;
		}

		function testimonials_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Testimonials', 'adamas-vc-shortcodes' ),
					'base'        => 'st_testimonials_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/testimonials.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Testimonials', 'adamas-vc-shortcodes' ), // TODO : Add description
					'params'      => array(
						array(
							'type'        => 'dropdown',
							'heading'     => __( 'Module layout', 'adamas-vc-shortcodes' ),
							'param_name'  => 'testimonial_layout',
							'description' => '',
							'value'       => array(
								__( 'Style 1', 'adamas-vc-shortcodes' ) => 'style-1',
								__( 'Style 2', 'adamas-vc-shortcodes' ) => 'style-2',
								__( 'Style 3', 'adamas-vc-shortcodes' ) => 'style-3',
							),
						),
						array(
							'type'       => 'checkbox',
							'heading'    => __( 'Testimonials to display', 'adamas-vc-shortcodes' ),
							'param_name' => 'testimonials',
							'value'      => st_adamas_testimonials_select(),
						),
						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),

						// Client name typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Client name font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_name_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Client font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_name_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Client name color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_name_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Client name font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'client_name_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Client name line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_name_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Client name letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_name_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Client occupation typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Client occupation font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Client font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Client occupation color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client occupation font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client occupation line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Client occupation letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_occupation_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Client company typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Client company font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Client company font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Client company color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client company font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client company line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Client company letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_company_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Client comment typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Client comment font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Client comment font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Client comment color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client comment font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Client comment line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Client comment letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'client_comment_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_testimonials_module = new St_Testimonials_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_testimonials_module extends WPBakeryShortCode {
		}
	}
}