<?php

$el_class = $activity_title = $activity_link = $activity_desc = $activity_img = $module_animation = $animation = $animated = $css_style = '';
$output   = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'module_animation' => '',
	'activity_title'   => '',
	'activity_link'    => '',
	'activity_img'     => '',
	'el_class'         => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

$activity_title      = $atts['activity_title'];
$activity_img        = wp_get_attachment_image_src( $atts['activity_img'], 'full' );
$img_link            = $activity_img[0];
$activity_link       = $atts['activity_link'];
$activity_build_link = vc_build_link( $activity_link );
if ( '' !== $activity_build_link ) {
	$link_title  = $activity_build_link['title'];
	$link_url    = $activity_build_link['url'];
	$link_target = $activity_build_link['target'];
} else {
	$link_url = '';
}

if ( $activity_img ) {
	$css_style = 'background-image: url(' . esc_url( $img_link ) . ');';
}

if ( $link_target ) {
	$target = 'target="' . esc_attr( trim( $link_target ) ) . '"';
}

if ( ! empty( $activity_link['rel'] ) ) {
	$rel = ' rel="' . esc_attr( $activity_build_link['rel'] ) . '"';
} else {
	$rel = '';
}

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-activity-grid-item ' . esc_attr( $css_class ) . '">';
$output .= '<div class="st-activity-grid-item-inner" style="' . esc_attr( $css_style ) . '">';
$output .= '<div class="st-activity-grid-title-wrapper st-4 col"><h3 class="st-activity-grid-title ' . $animated . '" ' . $animation . '>' . esc_attr( $activity_title ) . '</h3><div class="st-activity-read-more ' . $animated . '" ' . $animation . '><a href="#"><span></span></a></div></div>';
$output .= '<div class="st-activity-grid-desc st-8 col"><div>' . wp_kses_post( wpb_js_remove_wpautop( $content, true ) ) . '';
if ( '' !== $link_url ) {
	$output .= '<div class="st-activity-grid-link"><a href="' . esc_url( $activity_build_link['url'] ) . '" title="' . esc_attr( $activity_title ) . '"';
	if ( isset( $target ) ) {
		$output .= '' . $target . ' ' . $rel . '>';
	} else {
		$output .= $rel . '>';
	}
	$output .= esc_html__( 'READ MORE', 'adamas-vc-shortcodes' );
	$output .= '</a></div>';
} else {
	$output .= '';
}
$output .= '</div>';
$output .= '</div>';
$output .= '</div>';
$output .= '</div>';

echo $output;