<?php

$product_info_title = $product_info_title_color = $product_info_subtitle = $product_info_subtitle_color = $product_info_desc = $product_info_desc_color = $product_info_content_color = $product_info_color = $product_info_align = $product_info_link = $product_info_link_color = $module_animation = $animated = $animation = $el_class = $output = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'product_info_title'          => '',
	'product_info_title_color'    => '',
	'product_info_subtitle'       => '',
	'product_info_subtitle_color' => '',
	'product_info_desc'           => '',
	'product_info_desc_color'     => '',
	'product_info_content_color'  => '',
	'product_info_color'          => '',
	'product_info_align'          => '',
	'product_info_link'           => '',
	'product_info_link_color'     => '',
	'module_animation'            => '',
	'el_class'                    => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

if ( $product_info_title_color ) {
	$title_style = 'style="color:' . esc_attr( $product_info_title_color ) . '"';
} else {
	$title_style = '';
}

if ( $product_info_subtitle_color ) {
	$subtitle_style = 'style="color:' . esc_attr( $product_info_subtitle_color ) . '"';
} else {
	$subtitle_style = '';
}

if ( $product_info_desc_color ) {
	$desc_style = 'style="color:' . esc_attr( $product_info_desc_color ) . '"';
} else {
	$desc_style = '';
}

if ( $product_info_content_color ) {
	$content_style = 'style="color:' . esc_attr( $product_info_content_color ) . '"';
} else {
	$content_style = '';
}

if ( $product_info_color ) {
	$sep_style = 'style="background-color:' . esc_attr( $product_info_color ) . '"';
} else {
	$sep_style = '';
}

if ( $product_info_align == 'align-right' ) {
	$align = ' align-right';
} else {
	$align = '';
}

if ( ! empty( $product_info_link_color ) ) {
	$link_style = 'style="color:' . esc_attr( $product_info_link_color ) . ';"';
} else {
	$link_style = '';
}

if ( ! empty( $product_info_link ) ) {
	$product_info_link = vc_build_link( $product_info_link );
	$link              = '<a class="st-product-info-link" ' . $link_style . ' href="' . esc_url( $product_info_link['url'] ) . '" ' . ( $product_info_link['target'] ? ' target="' . esc_attr( trim( $product_info_link['target'] ) ) . '"' : '' ) . ' title="' . esc_attr( $product_info_link['title'] ) . '" ' . ( $product_info_link['rel'] ? ' rel="' . esc_attr( $product_info_link['rel'] ) . '"' : '' ) . '>' . esc_attr( $product_info_link['title'] ) . '</a>';
} else {
	$link = '';
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-product-info' . esc_attr( $align ) . ' ' . $css_class . ' ' . $animated . '" ' . $animation . '>';
$output .= '<div class="st-product-info-inner">';
$output .= '<div class="st-product-info-title-wrapper">';
$output .= '<div class="st-product-info-title-sep" ' . $sep_style . '></div>';
$output .= '<div class="st-product-info-subtitle" ' . $subtitle_style . '>' . esc_attr( $product_info_subtitle ) . '</div>';
$output .= '<div class="st-product-info-title" ' . $title_style . '><h3>' . esc_attr( $product_info_title ) . '</h3></div>';
$output .= '</div>'; // st-product-info-title-wrapper
$output .= '<div class="st-product-info-short-desc" ' . $desc_style . '>' . esc_attr( $product_info_desc ) . '</div>';
$output .= '<div class="st-product-info-desc" ' . $content_style . '>' . wpb_js_remove_wpautop( $content, true ) . '</div>';
$output .= $link;
$output .= '</div>'; // st-product-info-inner
$output .= '</div>'; // st-product-info

echo $output;