<?php

$pyramid_bg_top = $pyramid_title_top = $pyramid_desc_top = $pyramid_link_top = $pyramid_bg_mid = $pyramid_title_mid = $pyramid_desc_mid = $pyramid_link_mid = $pyramid_bg_bot = $pyramid_title_bot = $pyramid_desc_bot = $pyramid_link_bot = $animated = $animation = $module_animation = $el_class = $output = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'pyramid_bg_top'    => '',
	'pyramid_title_top' => '',
	'pyramid_desc_top'  => '',
	'pyramid_link_top'  => '',
	'pyramid_bg_mid'    => '',
	'pyramid_title_mid' => '',
	'pyramid_desc_mid'  => '',
	'pyramid_link_mid'  => '',
	'pyramid_bg_bot'    => '',
	'pyramid_title_bot' => '',
	'pyramid_desc_bot'  => '',
	'pyramid_link_bot'  => '',
	'module_animation'  => '',
	'el_class'          => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

if ( $pyramid_bg_top ) {
	$style_top      = 'style="border-color: transparent transparent ' . esc_attr( $pyramid_bg_top ) . ' transparent;"';
	$desc_style_top = 'style="border-color:' . esc_attr( $pyramid_bg_top ) . ';"';
}

if ( $pyramid_bg_mid ) {
	$style_mid      = 'style="border-color: transparent transparent ' . esc_attr( $pyramid_bg_mid ) . ' transparent;"';
	$desc_style_mid = 'style="border-color:' . esc_attr( $pyramid_bg_mid ) . ';"';
}

if ( $pyramid_bg_bot ) {
	$style_bot      = 'style="border-color: transparent transparent ' . esc_attr( $pyramid_bg_bot ) . ' transparent;"';
	$desc_style_bot = 'style="border-color:' . esc_attr( $pyramid_bg_bot ) . ';"';
}

$pyramid_link_top_href = vc_build_link( $pyramid_link_top );
if ( $pyramid_link_top_href !== '' ) {
	$pyramid_link_top_target = ( $pyramid_link_top_href['target'] !== '' ) ? "target='" . esc_attr( trim( $pyramid_link_top_href['target'] ) ) . "'" : '';
	$pyramid_link_top_title  = ( $pyramid_link_top_href['title'] !== '' ) ? "title='" . esc_attr( $pyramid_link_top_href['title'] ) . "'" : '';
	if ( ! empty( $pyramid_link_top_href['rel'] ) ) {
		$pyramid_link_top_rel = ' rel="' . esc_attr( $pyramid_link_top_href['rel'] ) . '"';
	} else {
		$pyramid_link_top_rel = '';
	}
}

$pyramid_link_mid_href = vc_build_link( $pyramid_link_mid );
if ( $pyramid_link_mid_href !== '' ) {
	$pyramid_link_mid_target = ( $pyramid_link_mid_href['target'] !== '' ) ? "target='" . esc_attr( trim( $pyramid_link_mid_href['target'] ) ) . "'" : '';
	$pyramid_link_mid_title  = ( $pyramid_link_mid_href['title'] !== '' ) ? "title='" . esc_attr( $pyramid_link_mid_href['title'] ) . "'" : '';
	if ( ! empty( $pyramid_link_mid_href['rel'] ) ) {
		$pyramid_link_mid_rel = ' rel="' . esc_attr( $pyramid_link_mid_href['rel'] ) . '"';
	} else {
		$pyramid_link_mid_rel = '';
	}
}

$pyramid_link_bot_href = vc_build_link( $pyramid_link_bot );
if ( $pyramid_link_bot_href !== '' ) {
	$pyramid_link_bot_target = ( $pyramid_link_bot_href['target'] !== '' ) ? "target='" . esc_attr( trim( $pyramid_link_bot_href['target'] ) ) . "'" : '';
	$pyramid_link_bot_title  = ( $pyramid_link_bot_href['title'] !== '' ) ? "title='" . esc_attr( $pyramid_link_bot_href['title'] ) . "'" : '';
	if ( ! empty( $pyramid_link_bot_href['rel'] ) ) {
		$pyramid_link_bot_rel = ' rel="' . esc_attr( $pyramid_link_bot_href['rel'] ) . '"';
	} else {
		$pyramid_link_bot_rel = '';
	}
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-pyramid ' . $css_class . ' ' . $animated . '" ' . $animation . '>';
if ( $pyramid_link_top !== '' ) {
	$output .= '<a href="' . esc_url( $pyramid_link_top_href['url'] ) . '" ' . $pyramid_link_top_title . ' ' . $pyramid_link_top_target . ' ' . $pyramid_link_top_rel . '>';
}
$output .= '<div class="st-pyramid-top" ' . $style_top . '>';
$output .= '<div class="st-pyramid-top-title">' . esc_attr( $pyramid_title_top ) . '</div>';
$output .= '<div class="st-pyramid-top-inner" ' . $desc_style_top . '><div class="st-pyramid-top-desc">' . esc_attr( $pyramid_desc_top ) . '</div></div>';
$output .= '</div>'; // st-pyramid-top
if ( $pyramid_link_top !== '' ) {
	$output .= '</a>';
}
if ( $pyramid_link_mid !== '' ) {
	$output .= '<a href="' . esc_url( $pyramid_link_mid_href['url'] ) . '" ' . $pyramid_link_mid_title . ' ' . $pyramid_link_mid_target . ' ' . $pyramid_link_mid_rel . '>';
}
$output .= '<div class="st-pyramid-mid" ' . $style_mid . '>';
$output .= '<div class="st-pyramid-mid-title">' . esc_attr( $pyramid_title_mid ) . '</div>';
$output .= '<div class="st-pyramid-mid-inner" ' . $desc_style_mid . '><div class="st-pyramid-mid-desc">' . esc_attr( $pyramid_desc_mid ) . '</div></div>';
$output .= '</div>'; // st-pyramid-mid
if ( $pyramid_link_mid !== '' ) {
	$output .= '</a>';
}
if ( $pyramid_link_bot !== '' ) {
	$output .= '<a href="' . esc_url( $pyramid_link_bot_href['url'] ) . '" ' . $pyramid_link_bot_title . ' ' . $pyramid_link_bot_target . ' ' . $pyramid_link_bot_rel . '>';
}
$output .= '<div class="st-pyramid-bot" ' . $style_bot . '>';
$output .= '<div class="st-pyramid-bot-title">' . esc_attr( $pyramid_title_bot ) . '</div>';
$output .= '<div class="st-pyramid-bot-inner" ' . $desc_style_bot . '><div class="st-pyramid-bot-desc">' . esc_attr( $pyramid_desc_bot ) . '</div></div>';
$output .= '</div>'; // st-pyramid-bot
if ( $pyramid_link_bot !== '' ) {
	$output .= '</a>';
}
$output .= '</div>'; // st-pyramid

echo $output;