<?php
$video_source     = $mp4_video = $webm_video = $youtube_video = $vimeo_video = '';
$icon_type        = $icon = $icon_img = $icon_img_width = $icon_size = $icon_color = $icon_bg_size = $icon_bg_color = '';
$border_radius    = $border_style = $border_width = $border_color = '';
$icon_color_hover = $bg_color_hover = $border_color_hover = '';
$bg_image         = $image_width = $image_height = '';
$el_class         = $output = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

$el_class = isset( $atts['el_class'] ) ? $atts['el_class'] : '';
$id       = uniqid( 'st-video-popup-' );

$icon_output = '';

if ( $icon_type == 'image-icon' ) {
	$image_icon     = wp_get_attachment_image_src( $icon_img, 'full' );
	$image_icon_url = $image_icon[0];
	$image_alt      = get_post_meta( $icon_img, '_wp_attachment_image_alt', true );
	if ( ! empty( $icon_img_width ) ) {
		$image_icon_style = 'style="width:' . esc_attr( $icon_img_width ) . 'px;"';
	} else {
		$image_icon_style = '';
	}
	$icon_output = '<div class="st-video-popup-icon"><img src="' . esc_url( $image_icon_url ) . '" alt="' . esc_attr( $image_alt ) . '" ' . $image_icon_style . '></div>';
} else {
	$font_icon_style = '';
	if ( $icon_color !== '' ) {
		$font_icon_style .= 'style="';
		if ( $icon_color !== '' ) {
			$font_icon_style .= 'color:' . esc_attr( $icon_color ) . ';';
		}
		$font_icon_style .= '"';
	}

	$font_icon_bg_style = '';
	if ( $icon_size !== '' || $icon_bg_size !== '' || $icon_bg_color !== '' || $border_radius !== '' || $border_style !== '' || $border_width !== '' || $border_color !== '' ) {
		$font_icon_bg_style .= 'style="';
		if ( $icon_size !== '' ) {
			$font_icon_bg_style .= 'font-size:' . esc_attr( $icon_size ) . 'px;';
		}
		if ( $icon_bg_size !== '' ) {
			$font_icon_bg_style .= 'width:' . esc_attr( $icon_bg_size ) . 'px;height:' . esc_attr( $icon_bg_size ) . 'px;line-height:' . esc_attr( $icon_bg_size ) . 'px;';
		}
		if ( $icon_bg_color !== '' ) {
			$font_icon_bg_style .= 'background:' . esc_attr( $icon_bg_color ) . ';';
		}
		if ( $border_radius !== '' ) {
			$font_icon_bg_style .= 'border-radius:' . esc_attr( $border_radius ) . 'px;';
		}
		if ( $border_style !== '' ) {
			$font_icon_bg_style .= 'border-style:' . esc_attr( $border_style ) . ';';
		}
		if ( $border_width !== '' ) {
			$font_icon_bg_style .= 'border-width:' . esc_attr( $border_width ) . 'px;';
		}
		if ( $border_color !== '' ) {
			$font_icon_bg_style .= 'border-color:' . esc_attr( $border_color ) . ';';
		}
		$font_icon_bg_style .= '"';
	}

	$icon_output = '<div class="st-video-popup-icon" ' . $font_icon_bg_style . '><i class="' . esc_attr( $icon ) . '" ' . $font_icon_style . '></i></div>';
}

$hover_style = '';
if ( $bg_color_hover !== '' || $border_color_hover !== '' || $icon_color_hover !== '' ) {
	$hover_style .= '<style type="text/css">';
	if ( $bg_color_hover !== '' || $border_color_hover !== '' ) {
		$hover_style .= '#' . esc_attr( $id ) . ' a.st-video-popup-link .st-video-popup-icon:hover{';
		if ( $bg_color_hover !== '' ) {
			$hover_style .= 'background:' . $bg_color_hover . '!important;';
		}
		if ( $border_color_hover !== '' ) {
			$hover_style .= 'border-color:' . $border_color_hover . '!important;';
		}
		$hover_style .= '}';
	}
	if ( $icon_color_hover !== '' ) {
		$hover_style .= '#' . esc_attr( $id ) . ' a.st-video-popup-link .st-video-popup-icon:hover i{color:' . $icon_color_hover . '!important}';
	}
	$hover_style .= '</style>';
}

$wrapper_style = '';
if ( $bg_image !== '' || $image_width !== '' || $image_height !== '' ) {
	$wrapper_style .= 'style="';
	if ( $bg_image !== '' ) {
		$image         = wp_get_attachment_image_src( $bg_image, 'full' );
		$image_url     = $image[0];
		$wrapper_style .= 'background-image:url(' . esc_url( $image_url ) . ');';
	}
	if ( $image_width !== '' ) {
		$wrapper_style .= 'width:' . esc_attr( $image_width ) . ';';
	}
	if ( $image_height !== '' ) {
		$wrapper_style .= 'height:' . esc_attr( $image_height ) . ';';
	}
	$wrapper_style .= '"';
}

if ( ! empty( $youtube_video ) ) {
	$video_url = $youtube_video;
} elseif ( ! empty( $vimeo_video ) ) {
	$video_url = $vimeo_video;
} elseif ( ! empty( $mp4_video ) || ! empty( $webm_video ) ) {
	$video_url1 = $mp4_video;
	$video_url2 = $webm_video;
} elseif ( empty( $mp4_video ) ) {
	$video_url1 = $webm_video;
	$video_url2 = $webm_video;
} elseif ( empty( $webm_video ) ) {
	$video_url1 = $mp4_video;
	$video_url2 = $mp4_video;
} else {
	$video_url = $video_url1 = $video_url2 = '';
}

wp_enqueue_style( 'magnific-popup', get_template_directory_uri() . '/assets/css/magnific-popup.css', false, null );
wp_enqueue_script( 'magnific-popup', get_template_directory_uri() . '/assets/js/jquery.magnific-popup.min.js', array( 'jquery' ), false, true );

$popup_script = '';
$popup_script .= 'jQuery(document).ready(function($){"use strict";';
if ( ! empty( $video_url2 ) ) {
	$popup_script .= '
        var sBrowser, sUsrAg = navigator.userAgent;
        if (sUsrAg.indexOf("Opera") > -1) {
            sBrowser = "Opera";
        } else if (sUsrAg.indexOf("Firefox") > -1) {
            sBrowser = "Mozilla Firefox";
        }
        
        if(sBrowser == "Opera" || sBrowser == "Mozilla Firefox"){
            $("#' . esc_js( $id ) . ' a.st-video-popup-link.mp4").addClass("hide");
        } else {
            $("#' . esc_js( $id ) . ' a.st-video-popup-link.webm").addClass("hide");
        }
    ';
}
$popup_script .= ' 
    $("#' . esc_js( $id ) . ' a.st-video-popup-link").magnificPopup({type:"iframe"});
});
';

wp_add_inline_script( 'magnific-popup', $popup_script );

$class_to_filter = 'st-video-popup';
$class_to_filter .= $this->getExtraClass( $el_class );
$css_class       = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $class_to_filter, $this->settings['base'], $atts );

$output .= '<div id="' . esc_attr( $id ) . '" class="' . esc_attr( $css_class ) . '" ' . $wrapper_style . '>';
if ( $video_source === 'youtube' || $video_source === 'vimeo' ) {
	if ( ! empty( $video_url ) ) {
		$output .= '<a href="' . esc_url( $video_url ) . '" class="st-video-popup-link">' . $icon_output . '</a>';
	}
} elseif ( $video_source === 'media' && ( ! empty( $video_url1 ) || ! empty( $video_url2 ) ) ) {
	if ( ! empty( $video_url1 ) ) {
		$output .= '<a href="' . esc_url( $video_url1 ) . '" class="st-video-popup-link mp4">' . $icon_output . '</a>';
	}
	if ( ! empty( $video_url2 ) ) {
		$output .= '<a href="' . esc_url( $video_url2 ) . '" class="st-video-popup-link webm">' . $icon_output . '</a>';
	}
}
$output .= '</div>';

if ( $hover_style != '' ) {
	$output .= "<script type=\"text/javascript\">jQuery(document).ready(function(){jQuery('head').append('" . $hover_style . "');});</script>";
}

echo $output;