<?php
/*
* Add-on Name: Team Member Info Module
*/
if ( ! class_exists( 'St_Team_Member_Info_Module' ) ) {
	class St_Team_Member_Info_Module {
		function __construct() {
			add_shortcode( 'st_team_member_info_module', array( $this, 'team_member_info_module_shortcode' ) );
			add_action( 'init', array( $this, 'team_member_info_module_init' ) );
		}

		function team_member_info_module_shortcode( $atts, $content ) {
			$output = $team_member_photo = $team_member_info_title = $team_member_info_contact = $team_member_info_location = $team_member_facebook = $team_member_vkontakte = $team_member_twitter = $team_member_googleplus = $team_member_pinterest = $team_member_linkedin = $team_member_instagram = $team_member_phone_1 = $team_member_phone_2 = $team_member_phone_3 = $team_member_email = $team_member_skype = $team_member_whatsapp = $team_member_website = $team_member_info_location_details = $team_member_title_font = $team_member_title_font_style = $team_member_title_color = $team_member_info_title_font_size = $team_member_title_line_height = $team_member_title_letter_spacing = $team_member_desc_font = $team_member_desc_font_style = $team_member_desc_color = $team_member_desc_font_size = $team_member_desc_line_height = $team_member_desc_letter_spacing = $team_member_info_location_details = $bg_img = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'team_member_photo'                 => '',
				'team_member_info_title'            => '',
				'team_member_info_contact'          => '',
				'team_member_info_location'         => '',
				'team_member_facebook'              => '',
				'team_member_twitter'               => '',
				'team_member_vkontakte'             => '',
				'team_member_googleplus'            => '',
				'team_member_pinterest'             => '',
				'team_member_linkedin'              => '',
				'team_member_instagram'             => '',
				'team_member_phone_1'               => '',
				'team_member_phone_2'               => '',
				'team_member_phone_3'               => '',
				'team_member_email'                 => '',
				'team_member_skype'                 => '',
				'team_member_whatsapp'              => '',
				'team_member_info_location_details' => '',
				'team_member_title_font'            => '',
				'team_member_title_font_style'      => '',
				'team_member_title_color'           => '',
				'team_member_title_font_size'       => '',
				'team_member_title_line_height'     => '',
				'team_member_title_letter_spacing'  => '',
				'team_member_desc_font'             => '',
				'team_member_desc_font_style'       => '',
				'team_member_desc_color'            => '',
				'team_member_desc_font_size'        => '',
				'team_member_desc_line_height'      => '',
				'team_member_desc_letter_spacing'   => '',
				'module_animation'                  => '',
				'el_class'                          => '',
			), $atts ) );

			// Animation TODO :
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$id = uniqid( 'st-team-member-info-' );

			$img      = wp_get_attachment_image_src( $team_member_photo, 'full' );
			$img_link = $img[0];

			if ( $img ) {
				$bg_img = ' style="background-image:url(' . esc_url( $img_link ) . ');"';
			}

			// Team member title
			$team_member_title_style = 'style="';

			if ( $team_member_title_font !== '' ) {
				$team_member_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $team_member_title_font ) : '';
				$team_member_title_style       .= ! empty( $team_member_title_font_family ) ? 'font-family:\'' . $team_member_title_font_family . '\';' : '';
			}

			if ( is_numeric( $team_member_title_font_size ) ) {
				$team_member_title_font_size = 'desktop: ' . $team_member_title_font_size . 'px;';
			}
			if ( is_numeric( $team_member_title_line_height ) ) {
				$team_member_title_line_height = 'desktop: ' . $team_member_title_line_height . 'px;';
			}

			$team_member_title_args = array(
				'target'      => '#' . $id . ' .st-team-member-title',
				'media_sizes' => array(
					'font-size'   => $team_member_title_font_size,
					'line-height' => $team_member_title_line_height,
				),
			);

			$team_member_title_responsive = get_ultimate_vc_responsive_media_css( $team_member_title_args );
			$team_member_title_style      .= $team_member_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $team_member_title_letter_spacing ) . 'px;' : '';
			$team_member_title_style      .= '"';

			// Team member description
			$team_member_desc_style = 'style="';

			if ( $team_member_desc_font !== '' ) {
				$team_member_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $team_member_desc_font ) : '';
				$team_member_desc_style       .= ! empty( $team_member_desc_font_family ) ? 'font-family:\'' . $team_member_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $team_member_desc_font_size ) ) {
				$team_member_desc_font_size = 'desktop: ' . $team_member_desc_font_size . 'px;';
			}
			if ( is_numeric( $team_member_desc_line_height ) ) {
				$team_member_desc_line_height = 'desktop: ' . $team_member_desc_line_height . 'px;';
			}

			$team_member_desc_args = array(
				'target'      => '#' . $id . ' .st-team-member-desc',
				'media_sizes' => array(
					'font-size'   => $team_member_desc_font_size,
					'line-height' => $team_member_desc_line_height,
				),
			);

			$team_member_desc_responsive = get_ultimate_vc_responsive_media_css( $team_member_desc_args );
			$team_member_desc_style      .= $team_member_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $team_member_desc_letter_spacing ) . 'px;' : '';
			$team_member_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-team-member-info ' . esc_attr( $el_class ) . ' ' . $animated . '" ' . $animation . ' id="' . esc_attr( $id ) . '">';
			$output .= '<div class="st-team-member-info-photo"' . $bg_img . '>';
			$output .= '<div class="st-team-member-info-socials">';
			if ( $team_member_facebook !== '' ) {
				$facebook_href = vc_build_link( $team_member_facebook );
				if ( $facebook_href !== '' ) {
					$facebook_target = ( $facebook_href['target'] !== '' ) ? "target='" . esc_attr( trim( $facebook_href['target'] ) ) . "'" : '';
					$facebook_title  = ( $facebook_href['title'] !== '' ) ? "title='" . esc_attr( $facebook_href['title'] ) . "'" : '';
					if ( ! empty( $facebook_href['rel'] ) ) {
						$facebook_rel = ' rel="' . esc_attr( $facebook_href['rel'] ) . '"';
					} else {
						$facebook_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $facebook_href['url'] ) . '" ' . $facebook_title . ' ' . $facebook_target . ' ' . $facebook_rel . '><i class="fa fa-facebook" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_vkontakte !== '' ) {
				$vk_href = vc_build_link( $team_member_vkontakte );
				if ( $vk_href !== '' ) {
					$vk_target = ( $vk_href['target'] !== '' ) ? "target='" . esc_attr( trim( $vk_href['target'] ) ) . "'" : '';
					$vk_title  = ( $vk_href['title'] !== '' ) ? "title='" . esc_attr( $vk_href['title'] ) . "'" : '';
					if ( ! empty( $vk_href['rel'] ) ) {
						$vk_rel = ' rel="' . esc_attr( $vk_href['rel'] ) . '"';
					} else {
						$vk_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $vk_href['url'] ) . '" ' . $vk_title . ' ' . $vk_target . ' ' . $vk_rel . '><i class="fa fa-vk" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_twitter !== '' ) {
				$twitter_href = vc_build_link( $team_member_twitter );
				if ( $twitter_href !== '' ) {
					$twitter_target = ( $twitter_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $twitter_href['target'] ) ) . '"' : '';
					$twitter_title  = ( $twitter_href['title'] !== '' ) ? 'title="' . esc_attr( $twitter_href['title'] ) . '"' : '';
					if ( ! empty( $twitter_href['rel'] ) ) {
						$twitter_rel = ' rel="' . esc_attr( $twitter_href['rel'] ) . '"';
					} else {
						$twitter_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_attr( $twitter_href['url'] ) . '" ' . $twitter_title . ' ' . $twitter_target . ' ' . $twitter_rel . '><i class="fa fa-twitter" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_googleplus !== '' ) {
				$googleplus_href = vc_build_link( $team_member_googleplus );
				if ( $googleplus_href !== '' ) {
					$googleplus_target = ( $googleplus_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $googleplus_href['target'] ) ) . '"' : '';
					$googleplus_title  = ( $googleplus_href['title'] !== '' ) ? 'title="' . esc_attr( $googleplus_href['title'] ) . '"' : '';
					if ( ! empty( $googleplus_href['rel'] ) ) {
						$googleplus_rel = ' rel="' . esc_attr( $googleplus_href['rel'] ) . '"';
					} else {
						$googleplus_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $googleplus_href['url'] ) . '" ' . $googleplus_title . ' ' . $googleplus_target . ' ' . $googleplus_rel . '><i class="fa fa-google-plus" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_pinterest !== '' ) {
				$pinterest_href = vc_build_link( $team_member_pinterest );
				if ( $pinterest_href['url'] !== '' ) {
					$pinterest_target = ( $pinterest_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $pinterest_href['target'] ) ) . '"' : '';
					$pinterest_title  = ( $pinterest_href['title'] !== '' ) ? 'title="' . esc_attr( $pinterest_href['title'] ) . '"' : '';
					if ( ! empty( $pinterest_href['rel'] ) ) {
						$pinterest_rel = ' rel="' . esc_attr( $pinterest_href['rel'] ) . '"';
					} else {
						$pinterest_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $pinterest_href['url'] ) . '" ' . $pinterest_title . ' ' . $pinterest_target . ' ' . $pinterest_rel . '><i class="fa fa-pinterest-p" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_linkedin !== '' ) {
				$linkedin_href = vc_build_link( $team_member_linkedin );
				if ( $linkedin_href !== '' ) {
					$linkedin_target = ( $linkedin_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $linkedin_href['target'] ) ) . '"' : '';
					$linkedin_title  = ( $linkedin_href['title'] !== '' ) ? 'title="' . esc_attr( $linkedin_href['title'] ) . '"' : '';
					if ( ! empty( $linkedin_href['rel'] ) ) {
						$linkedin_rel = ' rel="' . esc_attr( $linkedin_href['rel'] ) . '"';
					} else {
						$linkedin_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $linkedin_href['url'] ) . '" ' . $linkedin_title . ' ' . $linkedin_target . ' ' . $linkedin_rel . '><i class="fa fa-linkedin" aria-hidden="true"></i></a></div>';
				}
			}
			if ( $team_member_instagram !== '' ) {
				$instagram_href = vc_build_link( $team_member_instagram );
				if ( $instagram_href !== '' ) {
					$instagram_target = ( $instagram_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $instagram_href['target'] ) ) . '"' : '';
					$instagram_title  = ( $instagram_href['title'] !== '' ) ? 'title="' . esc_attr( $instagram_href['title'] ) . '"' : '';
					if ( ! empty( $instagram_href['rel'] ) ) {
						$instagram_rel = ' rel="' . esc_attr( $instagram_href['rel'] ) . '"';
					} else {
						$instagram_rel = '';
					}
					$output .= '<div class="st-team-member-info-social"><a href="' . esc_url( $instagram_href['url'] ) . '" ' . $instagram_title . ' ' . $instagram_target . ' ' . $instagram_rel . '><i class="fa fa-instagram" aria-hidden="true"></i></a></div>';
				}
			}
			$output .= '</div>'; // st-team-member-info-socials
			$output .= '</div>'; // st-team-member-info-photo
			$output .= '<div class="st-team-member-info-inner">';
			$output .= '<div class="st-team-member-info-specialization">';
			$output .= '<div class="st-team-member-title ult-responsive" ' . $team_member_title_style . ' ' . $team_member_title_responsive . '><h3>' . esc_attr( $team_member_info_title ) . '</h3></div>';
			$output .= '<div class="st-team-member-desc ult-responsive" ' . $team_member_desc_style . ' ' . $team_member_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
			$output .= '</div>'; // st-team-member-info-specialization
			$output .= '<div class="st-team-member-info-contact">';
			$output .= '<div class="st-team-member-title ult-responsive" ' . $team_member_title_style . ' ' . $team_member_title_responsive . '><h3>' . esc_attr( $team_member_info_contact ) . '</h3></div>';
			$output .= '<div class="st-team-member-desc ult-responsive" ' . $team_member_desc_style . ' ' . $team_member_desc_responsive . '>';
			if ( $team_member_phone_1 !== '' ) {
				$output .= '<div class="st-team-member-info-contact-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone_1 ) ) . '">' . esc_attr( $team_member_phone_1 ) . '</a></div>';
			}
			if ( $team_member_phone_2 !== '' ) {
				$output .= '<div class="st-team-member-info-contact-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone_2 ) ) . '">' . esc_attr( $team_member_phone_2 ) . '</a></div>';
			}
			if ( $team_member_phone_3 !== '' ) {
				$output .= '<div class="st-team-member-info-contact-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $team_member_phone_3 ) ) . '">' . esc_attr( $team_member_phone_3 ) . '</a></div>';
			}
			if ( $team_member_email !== '' ) {
				$output .= '<div class="st-team-member-info-contact-email"><i class="fa fa-envelope" aria-hidden="true"></i><a href="mailto:' . sanitize_email( $team_member_email ) . '">' . sanitize_email( $team_member_email ) . '</a></div>';
			}
			if ( $team_member_skype !== '' ) {
				$output .= '<div class="st-team-member-info-contact-skype"><i class="fa fa-skype" aria-hidden="true"></i><a href="callTo:' . esc_attr( $team_member_skype ) . '">' . esc_attr( $team_member_skype ) . '</a></div>';
			}
			if ( $team_member_whatsapp !== '' ) {
				$output .= '<div class="st-team-member-info-contact-whatsapp"><i class="fa fa-whatsapp" aria-hidden="true"></i><span>' . esc_attr( $team_member_whatsapp ) . '</span></div>';
			}
			$output .= '</div>'; // st-team-member-desc
			$output .= '</div>'; // st-team-member-info-contact
			$output .= '<div class="st-team-member-info-location">';
			$output .= '<div class="st-team-member-title ult-responsive" ' . $team_member_title_style . ' ' . $team_member_title_responsive . '><h3>' . esc_attr( $team_member_info_location ) . '</h3></div>';
			$output .= '<div class="st-team-member-desc ult-responsive" ' . $team_member_desc_style . ' ' . $team_member_desc_responsive . '><i class="fa fa-map-marker" aria-hidden="true"></i><span>' . wp_kses_post( $team_member_info_location_details ) . '</span></div>';
			$output .= '</div>'; // st-team-member-info-location
			$output .= '</div>'; // st-team-member-info-inner
			$output .= '</div>'; // st-team-member-info

			return $output;
		}

		function team_member_info_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Team Member Info', 'adamas-vc-shortcodes' ),
					'base'        => 'st_team_member_info_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/team_member_info.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays members detailed information', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Photo', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_photo',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Description title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_info_title',
							'description' => '',
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Contact title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_info_contact',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Phone', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_phone_1',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Phone 2', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_phone_2',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Phone 3', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_phone_3',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Email', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_email',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Skype', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_skype',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Whatsapp', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_whatsapp',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Location title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_info_location',
							'description' => '',
						),
						array(
							'type'        => 'textarea',
							'heading'     => __( 'Location info', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_info_location_details',
							'description' => ''
						),

						// Socials
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Facebook', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_facebook',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Twitter', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_twitter',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Google Plus', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_googleplus',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Pinterest', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_pinterest',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Linked In', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_linkedin',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Instagram', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_instagram',
							'group'       => 'Social',
							'description' => ''
						),
						array(
							'type'        => 'vc_link',
							'heading'     => __( 'VK', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_vkontakte',
							'group'       => 'Social',
							'description' => ''
						),

						// Team member name typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Name font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Name font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Name font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Name line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Name letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_name_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Team member description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'team_member_description_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_team_member_info_module = new St_Team_Member_Info_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_team_member_info_module extends WPBakeryShortCode {
		}
	}
}