<?php
/*
 * Add-on Name: Vacancy Table Module
 */
if ( ! class_exists( 'St_Vacancy_Table_Module' ) ) {
	class St_Vacancy_Table_Module {
		function __construct() {
			add_shortcode( 'st_vacancy_table_module', array( $this, 'vacancy_table_module_shortcode' ) );
			add_action( 'init', array( $this, 'vacancy_table_module_init' ) );
		}

		function vacancy_table_module_shortcode( $atts ) {
			$output          = $first_column_title = $second_column_title = $third_column_title = $fourth_column_title = $table_data = $link = $position = $department = $location = $date = '';
			$title_font      = $title_font_style = $title_font_color = $title_font_size = $title_line_height = $title_letter_spacing = '';
			$position_font   = $position_font_style = $position_font_color = $position_font_size = $position_line_height = $position_letter_spacing = '';
			$department_font = $department_font_style = $department_font_color = $department_font_size = $department_line_height = $department_letter_spacing = '';
			$location_font   = $location_font_style = $location_font_color = $location_font_size = $location_line_height = $location_letter_spacing = '';
			$date_font       = $date_font_style = $date_font_color = $date_font_size = $date_line_height = $date_letter_spacing = '';
			$el_class        = $module_animation = $animation = $animated = '';

			extract( shortcode_atts( array(
				'first_column_title'        => '',
				'second_column_title'       => '',
				'third_column_title'        => '',
				'fourth_column_title'       => '',
				'table_data'                => '',
				'link'                      => '',
				'position'                  => '',
				'department'                => '',
				'location'                  => '',
				'date'                      => '',
				'title_font'                => '',
				'title_font_style'          => '',
				'title_font_color'          => '',
				'title_font_size'           => '',
				'title_line_height'         => '',
				'title_letter_spacing'      => '',
				'position_font'             => '',
				'position_font_style'       => '',
				'position_font_color'       => '',
				'position_font_size'        => '',
				'position_line_height'      => '',
				'position_letter_spacing'   => '',
				'department_font'           => '',
				'department_font_style'     => '',
				'department_font_color'     => '',
				'department_font_size'      => '',
				'department_line_height'    => '',
				'department_letter_spacing' => '',
				'location_font'             => '',
				'location_font_style'       => '',
				'location_font_color'       => '',
				'location_font_size'        => '',
				'location_line_height'      => '',
				'location_letter_spacing'   => '',
				'date_font'                 => '',
				'date_font_style'           => '',
				'date_font_color'           => '',
				'date_font_size'            => '',
				'date_line_height'          => '',
				'date_letter_spacing'       => '',
				'module_animation'          => '',
				'el_class'                  => '',
			), $atts ) );

			$link_count       = 0;
			$position_count   = 0;
			$department_count = 0;
			$location_count   = 0;
			$date_count       = 0;

			$table_data = json_decode( urldecode( $table_data ), true );

			$id = uniqid( 'st-vacancy-table-' );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			// Table title
			$title_style = ' style="';

			if ( $title_font !== '' ) {
				$title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $title_font ) : '';
				if ( $title_font_family !== '' ) {
					$title_style .= 'font-family:\'' . $title_font_family . '\';';
				}
			}

			if ( $title_font_style !== '' ) {
				$title_style .= esc_attr( $title_font_style );
			}

			if ( is_numeric( $title_font_size ) ) {
				$title_font_size = 'desktop:' . $title_font_size . 'px;';
			}

			if ( is_numeric( $title_line_height ) ) {
				$title_line_height = 'desktop:' . $title_line_height . 'px;';
			}

			$title_args = array(
				'target'      => "#" . $id . " .st-vacancy-table-title",
				'media_sizes' => array(
					'font-size'   => $title_font_size,
					'line-height' => $title_line_height,
				),
			);

			$title_responsive = get_ultimate_vc_responsive_media_css( $title_args );

			$title_style .= $title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $title_letter_spacing ) . 'px;' : '';
			$title_style .= $title_font_color !== '' ? 'color:' . esc_attr( $title_font_color ) . ';' : '';
			$title_style .= '"';

			// Position
			$position_style = ' style="';

			if ( $position_font !== '' ) {
				$position_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $position_font ) : '';
				if ( $position_font_family !== '' ) {
					$position_style .= 'font-family:\'' . $position_font_family . '\';';
				}
			}

			if ( $position_font_style !== '' ) {
				$position_style .= esc_attr( $position_font_style );
			}

			if ( is_numeric( $position_font_size ) ) {
				$position_font_size = 'desktop:' . $position_font_size . 'px;';
			}

			if ( is_numeric( $position_line_height ) ) {
				$position_line_height = 'desktop:' . $position_line_height . 'px;';
			}

			$position_args = array(
				'target'      => "#" . $id . " .st-vacancy-table-position",
				'media_sizes' => array(
					'font-size'   => $position_font_size,
					'line-height' => $position_line_height,
				),
			);

			$position_responsive = get_ultimate_vc_responsive_media_css( $position_args );

			$position_style .= $position_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $position_letter_spacing ) . 'px;' : '';
			$position_style .= $position_font_color !== '' ? 'color:' . esc_attr( $position_font_color ) . ';' : '';
			$position_style .= '"';

			// Department
			$department_style = ' style="';

			if ( $department_font !== '' ) {
				$department_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $department_font ) : '';
				if ( $department_font_family !== '' ) {
					$department_style .= 'font-family:\'' . $department_font_family . '\';';
				}
			}

			if ( $department_font_style !== '' ) {
				$department_style .= esc_attr( $department_font_style );
			}

			if ( is_numeric( $department_font_size ) ) {
				$department_font_size = 'desktop:' . $department_font_size . 'px;';
			}

			if ( is_numeric( $department_line_height ) ) {
				$department_line_height = 'desktop:' . $department_line_height . 'px;';
			}

			$department_args = array(
				'target'      => "#" . $id . " .st-vacancy-table-department",
				'media_sizes' => array(
					'font-size'   => $department_font_size,
					'line-height' => $department_line_height,
				),
			);

			$department_responsive = get_ultimate_vc_responsive_media_css( $department_args );

			$department_style .= $department_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $department_letter_spacing ) . 'px;' : '';
			$department_style .= $department_font_color !== '' ? 'color:' . esc_attr( $department_font_color ) . ';' : '';
			$department_style .= '"';

			// Location
			$location_style = ' style="';

			if ( $location_font !== '' ) {
				$location_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $location_font ) : '';
				if ( $location_font_family !== '' ) {
					$location_style .= 'font-family:\'' . $location_font_family . '\';';
				}
			}

			if ( $location_font_style !== '' ) {
				$location_style .= esc_attr( $location_font_style );
			}

			if ( is_numeric( $location_font_size ) ) {
				$location_font_size = 'desktop:' . $location_font_size . 'px;';
			}

			if ( is_numeric( $location_line_height ) ) {
				$location_line_height = 'desktop:' . $location_line_height . 'px;';
			}

			$location_args = array(
				'target'      => "#" . $id . " .st-vacancy-table-location",
				'media_sizes' => array(
					'font-size'   => $location_font_size,
					'line-height' => $location_line_height,
				),
			);

			$location_responsive = get_ultimate_vc_responsive_media_css( $location_args );

			$location_style .= $location_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $location_letter_spacing ) . 'px;' : '';
			$location_style .= $location_font_color !== '' ? 'color:' . esc_attr( $location_font_color ) . ';' : '';
			$location_style .= '"';

			// Date
			$date_style = ' style="';

			if ( $date_font !== '' ) {
				$date_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $date_font ) : '';
				if ( $date_font_family !== '' ) {
					$date_style .= 'font-family:\'' . $date_font_family . '\';';
				}
			}

			if ( $date_font_style !== '' ) {
				$date_style .= esc_attr( $date_font_style );
			}

			if ( is_numeric( $date_font_size ) ) {
				$date_font_size = 'desktop:' . $date_font_size . 'px;';
			}

			if ( is_numeric( $date_line_height ) ) {
				$date_line_height = 'desktop:' . $date_line_height . 'px;';
			}

			$date_args = array(
				'target'      => "#" . $id . " .st-vacancy-table-date",
				'media_sizes' => array(
					'font-size'   => $date_font_size,
					'line-height' => $date_line_height,
				),
			);

			$date_responsive = get_ultimate_vc_responsive_media_css( $date_args );

			$date_style .= $date_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $date_letter_spacing ) . 'px;' : '';
			$date_style .= $date_font_color !== '' ? 'color:' . esc_attr( $date_font_color ) . ';' : '';
			$date_style .= '"';

			$output .= '<div class="st-vacancy-table" id="' . esc_attr( $id ) . '"><table>';
			$output .= '<thead><tr><th class="st-vacancy-table-title ult-responsive sort" ' . $title_style . ' ' . $title_responsive . ' data-sort="st-vacancy-table-position">' . $first_column_title . '</th><th class="st-vacancy-table-title ult-responsive sort" ' . $title_style . ' ' . $title_responsive . ' data-sort="st-vacancy-table-department">' . $second_column_title . '</th><th class="st-vacancy-table-title ult-responsive sort" ' . $title_style . ' ' . $title_responsive . ' data-sort="st-vacancy-table-location">' . $third_column_title . '</th><th class="st-vacancy-table-title ult-responsive sort" ' . $title_style . ' ' . $title_responsive . ' data-sort="st-vacancy-table-date">' . $fourth_column_title . '</th></tr></thead>';
			$output .= '<tbody class="list">';
			if ( isset( $table_data ) ) {
				foreach ( $table_data as $table_datas ) {
					$link   = isset( $table_datas['link'] ) ? $table_datas['link'] : '';
					$output .= '<tr>';
					if ( isset( $table_datas['position'] ) ) {
						$output .= '<td class="st-vacancy-table-position ult-responsive" ' . $position_style . ' ' . $position_responsive . '>';
						if ( $link !== '' ) {
							$link_href = vc_build_link( $link );
							if ( $link_href !== '' ) {
								$link_target = ( $link_href['target'] !== '' ) ? "target='" . esc_attr( trim( $link_href['target'] ) ) . "'" : '';
								$link_title  = ( $link_href['title'] !== '' ) ? "title='" . esc_attr( $link_href['title'] ) . "'" : '';
								if ( ! empty( $link_href['rel'] ) ) {
									$rel = ' rel="' . esc_attr( $link_href['rel'] ) . '"';
								} else {
									$rel = '';
								}
								$output .= '<a href="' . esc_url( $link_href['url'] ) . '" ' . $link_title . ' ' . $link_target . ' ' . $rel . '>';
							}
						}
						$output .= esc_attr( $table_datas['position'] );
						if ( $link !== '' ) {
							$output .= '</a>';
						}
						$output .= '</td>';
					}
					if ( isset( $table_datas['department'] ) ) {
						$output .= '<td class="st-vacancy-table-department ult-responsive" ' . $department_style . ' ' . $department_responsive . '>' . esc_attr( $table_datas['department'] ) . '</td>';
					}
					if ( isset( $table_datas['location'] ) ) {
						$output .= '<td class="st-vacancy-table-location ult-responsive" ' . $location_style . ' ' . $location_responsive . '>' . esc_attr( $table_datas['location'] ) . '</td>';
					}
					if ( isset( $table_datas['date'] ) ) {
						$output .= '<td class="st-vacancy-table-date ult-responsive" ' . $date_style . ' ' . $date_responsive . '>' . esc_attr( $table_datas['date'] ) . '</td>';
					}
					$output .= '</tr>';
				}
			}
			$output .= '</tbody></table></div>';

			wp_enqueue_script( 'listJS', get_template_directory_uri() . '/assets/js/list.min.js', false, false, true );

			$output .= '<script type="text/javascript">
        (function($){
            "use strict";
            $(document).ready(function(){
                var options = {valueNames:["st-vacancy-table-position","st-vacancy-table-department","st-vacancy-table-location","st-vacancy-table-date"]};
                var userList = new List("' . esc_js( $id ) . '",options);
            });
        })(jQuery);
        </script>';

			return $output;
		}

		function vacancy_table_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'                    => __( 'Vacancy Table', 'adamas-vc-shortcodes' ),
					'base'                    => 'st_vacancy_table_module',
					'category'                => esc_html__( 'ST Addons', 'adamas-vc-shortcodes' ),
					'icon'                    => get_template_directory_uri() . '/assets/images/shortcode_icons/vacancy_table.png',
					'show_settings_on_create' => true,
					'params'                  => array(
						array(
							'type'        => 'textfield',
							'heading'     => __( 'First column title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'first_column_title',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Second column title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'second_column_title',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Third column title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'third_column_title',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Fourth column title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'fourth_column_title',
							'description' => '',
						),
						array(
							'type'        => 'param_group',
							'heading'     => __( 'Table content', 'adamas-vc-shortcodes' ),
							'param_name'  => 'table_data',
							'description' => __( 'Add table content here.', 'adamas-vc-shortcodes' ),
							'value'       => urlencode( json_encode( array(
								array(
									'link'       => '',
									'position'   => '',
									'department' => '',
									'location'   => '',
									'date'       => '',
								)
							) ) ),
							'params'      => array(
								array(
									'type'        => 'vc_link',
									'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
									'param_name'  => 'link',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'First column text', 'adamas-vc-shortcodes' ),
									'param_name'  => 'position',
									'description' => '',
									'admin_label' => true
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Second column text', 'adamas-vc-shortcodes' ),
									'param_name'  => 'department',
									'value'       => '',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Third column text', 'adamas-vc-shortcodes' ),
									'param_name'  => 'location',
									'value'       => '',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Fourth column text', 'adamas-vc-shortcodes' ),
									'param_name'  => 'date',
									'value'       => '',
									'description' => '',
								),
							),
						),

						// Table title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'title_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Position typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Position font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'position_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Position font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'position_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Position font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'position_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Position font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'position_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Position line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'position_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Position letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'position_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Department typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Department font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'department_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Department font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'department_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Department font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'department_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Department font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'department_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Department line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'department_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Department letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'department_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Location typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Location font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'location_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Location font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'location_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Location font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'location_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Location font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'location_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Location line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'location_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Location letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'location_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Date typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Date font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'date_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Date font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'date_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Date font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'date_font_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'       => 'ultimate_responsive',
							'class'      => '',
							'heading'    => __( 'Date font size', 'adamas-vc-shortcodes' ),
							'param_name' => 'date_font_size',
							'unit'       => 'px',
							'media'      => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'group'      => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => '',
							'heading'     => __( 'Date line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'date_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Date letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'date_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_vacancy_table_module = new St_Vacancy_Table_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_vacancy_table_module extends WPBakeryShortCode {
		}
	}
}