<?php
/*
* Add-on Name: Ultimate Headings
* Add-on URI: http://dev.brainstormforce.com
*/
if ( ! class_exists( "Ultimate_Headings" ) ) {
	class Ultimate_Headings {
		static $add_plugin_script;

		function __construct() {
			if ( Ultimate_VC_Addons::$uavc_editor_enable ) {
				add_action( "init", array( $this, "ultimate_headings_init" ) );
			}

			add_shortcode( "ultimate_heading", array( $this, "ultimate_headings_shortcode" ) );
			add_action( "wp_enqueue_scripts", array( $this, "register_headings_assets" ), 1 );
		}

		function register_headings_assets() {

			Ultimate_VC_Addons::ultimate_register_style( 'ultimate-headings-style', 'headings' );

			Ultimate_VC_Addons::ultimate_register_script( 'ultimate-headings-script', 'headings', false, array( 'jquery' ), ULTIMATE_VERSION, false );
		}

		function ultimate_headings_init() {
			if ( function_exists( "vc_map" ) ) {
				vc_map(
					array(
						"name"        => __( "Headings", "adamas-vc-shortcodes" ),
						"base"        => "ultimate_heading",
						"class"       => "vc_ultimate_heading",
						"icon"        => "vc_ultimate_heading",
						"category"    => "Ultimate VC Addons",
						"description" => __( "Awesome heading styles.", "adamas-vc-shortcodes" ),
						"params"      => array(
							array(
								'type'        => 'dropdown',
								'heading'     => __( 'Text source', 'adamas-vc-shortcodes' ),
								'param_name'  => 'source',
								'value'       => array(
									__( 'Custom text', 'adamas-vc-shortcodes' )        => '',
									__( 'Post or Page Title', 'adamas-vc-shortcodes' ) => 'post_title',
								),
								'std'         => '',
								'description' => __( 'Select text source.', 'adamas-vc-shortcodes' ),
							),
							array(
								'type'       => 'textfield',
								'heading'    => __( 'Title', 'adamas-vc-shortcodes' ),
								'param_name' => 'main_heading',
								'holder'     => 'div',
								'value'      => '',
								'dependency' => array(
									'element'  => 'source',
									'is_empty' => true,
								),
							),
							array(
								"type"        => "dropdown",
								"heading"     => __( "Tag", "adamas-vc-shortcodes" ),
								"param_name"  => "heading_tag",
								"value"       => array(
									__( "Default", "adamas-vc-shortcodes" ) => "h2",
									__( "H1", "adamas-vc-shortcodes" )      => "h1",
									__( "H3", "adamas-vc-shortcodes" )      => "h3",
									__( "H4", "adamas-vc-shortcodes" )      => "h4",
									__( "H5", "adamas-vc-shortcodes" )      => "h5",
									__( "H6", "adamas-vc-shortcodes" )      => "h6",
									__( "Div", "adamas-vc-shortcodes" )     => "div",
									__( "p", "adamas-vc-shortcodes" )       => "p",
									__( "span", "adamas-vc-shortcodes" )    => "span",
								),
								"description" => __( "Default is H2", "adamas-vc-shortcodes" ),
							),
							array(
								"type"             => "ult_param_heading",
								"text"             => __( "Heading Settings", "adamas-vc-shortcodes" ),
								"param_name"       => "main_heading_typograpy",
								//"dependency" => Array("element" => "main_heading", "not_empty" => true),
								"group"            => "Typography",
								"class"            => "ult-param-heading",
								'edit_field_class' => 'ult-param-heading-wrapper no-top-margin vc_column vc_col-sm-12',
							),
							array(
								"type"        => "ultimate_google_fonts",
								"heading"     => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name"  => "main_heading_font_family",
								"description" => __( "Select the font of your choice.", "adamas-vc-shortcodes" ) . " " . __( "You can", "adamas-vc-shortcodes" ) . " <a target='_blank' rel='noopener' href='" . admin_url( 'admin.php?page=bsf-google-font-manager' ) . "'>" . __( "add new in the collection here", "adamas-vc-shortcodes" ) . "</a>.",
								//"dependency" => Array("element" => "main_heading", "not_empty" => true),
								"group"       => "Typography"
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "main_heading_style",
								//"description"	=>	__("Main heading font style", "smile"),
								//"dependency" => Array("element" => "main_heading", "not_empty" => true),
								"group"      => "Typography"
							),

							// Responsive Param
							array(
								"type"       => "ultimate_responsive",
								"class"      => "font-size",
								"heading"    => __( "Font size", 'adamas-vc-shortcodes' ),
								"param_name" => "main_heading_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography"
							),

							array(
								"type"       => "colorpicker",
								"class"      => "",
								"heading"    => __( "Font Color", "adamas-vc-shortcodes" ),
								"param_name" => "main_heading_color",
								"value"      => "",
								//"description" => __("Main heading color", "smile"),
								//"dependency" => Array("element" => "main_heading", "not_empty" => true),
								"group"      => "Typography"
							),

							// responsive
							array(
								"type"       => "ultimate_responsive",
								"class"      => "font-size",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "main_heading_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography"
							),

							array(
								"type"       => "text",
								"heading"    => "<h4>" . __( "Enter values with respective unites. Example - 10px, 10em, 10%, etc.", "adamas-vc-shortcodes" ) . "</h4>",
								"param_name" => "margin_design_tab_text",
								"group"      => "Design",
							),
							array(
								"type"       => "ultimate_margins",
								"heading"    => __( "Heading Margins", "adamas-vc-shortcodes" ),
								"param_name" => "main_heading_margin",
								"positions"  => array(
									"Top"    => "top",
									"Bottom" => "bottom"
								),
								//"dependency" => Array("element" => "main_heading", "not_empty" => true),
								"group"      => "Design"
							),
							array(
								"type"             => "textarea_html",
								"edit_field_class" => "ult_hide_editor_fullscreen vc_col-xs-12 vc_column wpb_el_type_textarea_html vc_wrapper-param-type-textarea_html vc_shortcode-param",
								"heading"          => __( "Sub Heading (Optional)", "adamas-vc-shortcodes" ),
								"param_name"       => "content",
								"value"            => "",
								//"description" => __("Sub heading text", "smile"),
							),
							array(
								"type"       => "checkbox",
								"heading"    => __( "Enable before/after heading element", "adamas-vc-shortcodes" ),
								"param_name" => "enable_heading_elem",
								"value"      => array( __( "Yes", "adamas-vc-shortcodes" ) => "yes" ),
							),
							array(
								"type"       => "dropdown",
								"heading"    => __( "Heading element type", "adamas-vc-shortcodes" ),
								"param_name" => "elem_type",
								"value"      => array(
									__( "Line gradient", "adamas-vc-shortcodes" )                  => "gradient",
									__( "Side line", "adamas-vc-shortcodes" )                      => "side",
									__( "Top line", "adamas-vc-shortcodes" )                       => "top",
									__( "Bottom line", "adamas-vc-shortcodes" )                    => "bottom",
									__( "Square", "adamas-vc-shortcodes" )                         => "square_3",
									__( "Square with empty space inside", "adamas-vc-shortcodes" ) => "square_2",
									__( "Square with line", "adamas-vc-shortcodes" )               => "square",
									__( "Circle", "adamas-vc-shortcodes" )                         => "circle",
									__( "Ring", "adamas-vc-shortcodes" )                           => "ring",
								),
								"dependency" => Array( "element" => "enable_heading_elem", "value" => "yes" ),
							),
							array(
								"type"        => "textfield",
								"heading"     => __( "Top element height", "adamas-vc-shortcodes" ),
								"param_name"  => "elem_top_height",
								"description" => __( "Set top element height (in px).", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "elem_type", "value" => "top" ),
							),
							array(
								"type"        => "textfield",
								"heading"     => __( "Bottom element height", "adamas-vc-shortcodes" ),
								"param_name"  => "elem_bottom_height",
								"description" => __( "Set bottom element height (in px).", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "elem_type", "value" => "bottom" ),
							),
							array(
								'type'       => 'colorpicker',
								'heading'    => __( 'Before/after heading element color', 'adamas-vc-shortcodes' ),
								'param_name' => 'heading_elem_color',
								"dependency" => Array( "element" => "enable_heading_elem", "value" => "yes" ),
							),
							array(
								"type"        => "checkbox",
								"heading"     => __( "Background check for heading element", "adamas-vc-shortcodes" ),
								"param_name"  => "heading_elem_bg_check",
								"description" => __( "Check this if heading placed on dark background.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "enable_heading_elem", "value" => "yes" ),
							),
							array(
								"type"             => "ult_param_heading",
								"text"             => __( "Sub Heading Settings", "adamas-vc-shortcodes" ),
								"param_name"       => "sub_heading_typograpy",
								//"dependency" => Array("element" => "content", "not_empty" => true),
								"group"            => "Typography",
								"class"            => "ult-param-heading",
								'edit_field_class' => 'ult-param-heading-wrapper vc_column vc_col-sm-12',
							),
							array(
								"type"        => "ultimate_google_fonts",
								"heading"     => __( "Font Family", "adamas-vc-shortcodes" ),
								"param_name"  => "sub_heading_font_family",
								"description" => __( "Select the font of your choice.", "adamas-vc-shortcodes" ) . " " . __( "You can", "adamas-vc-shortcodes" ) . " <a target='_blank' rel='noopener' href='" . admin_url( 'admin.php?page=bsf-google-font-manager' ) . "'>" . __( "add new in the collection here", "adamas-vc-shortcodes" ) . "</a>.",
								//"dependency" => Array("element" => "content", "not_empty" => true),
								"group"       => "Typography",
							),
							array(
								"type"       => "ultimate_google_fonts_style",
								"heading"    => __( "Font Style", "adamas-vc-shortcodes" ),
								"param_name" => "sub_heading_style",
								//"description"	=>	__("Sub heading font style", "smile"),
								//"dependency" => Array("element" => "content", "not_empty" => true),
								"group"      => "Typography",
							),

							// responsive font size
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Font Size", 'adamas-vc-shortcodes' ),
								"param_name" => "sub_heading_font_size",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography"
							),
							array(
								"type"       => "colorpicker",
								"class"      => "",
								"heading"    => __( "Font Color", "adamas-vc-shortcodes" ),
								"param_name" => "sub_heading_color",
								"value"      => "",
								//"description" => __("Sub heading color", "smile"),
								//"dependency" => Array("element" => "content", "not_empty" => true),
								"group"      => "Typography",
							),

							// responsive
							array(
								"type"       => "ultimate_responsive",
								"class"      => "",
								"heading"    => __( "Line Height", 'adamas-vc-shortcodes' ),
								"param_name" => "sub_heading_line_height",
								"unit"       => "px",
								"media"      => array(
									"Desktop"          => '',
									"Tablet"           => '',
									"Tablet Portrait"  => '',
									"Mobile Landscape" => '',
									"Mobile"           => '',
								),
								"group"      => "Typography"
							),
							array(
								"type"       => "ultimate_margins",
								"heading"    => "Sub Heading Margins",
								"param_name" => "sub_heading_margin",
								"positions"  => array(
									__( "Top", "adamas-vc-shortcodes" )    => "top",
									__( "Bottom", "adamas-vc-shortcodes" ) => "bottom"
								),
								//"dependency" => Array("element" => "sub_heading", "not_empty" => true),
								"group"      => "Design"
							),
							array(
								"type"       => "dropdown",
								"class"      => "",
								"heading"    => __( "Alignment", "adamas-vc-shortcodes" ),
								"param_name" => "alignment",
								"value"      => array(
									__( "Center", "adamas-vc-shortcodes" ) => "center",
									__( "Left", "adamas-vc-shortcodes" )   => "left",
									__( "Right", "adamas-vc-shortcodes" )  => "right"
								),
								//"description" => __("Text alignment", "smile"),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Separator", "adamas-vc-shortcodes" ),
								"param_name"  => "spacer",
								"value"       => array(
									__( "No Separator", "adamas-vc-shortcodes" )         => "no_spacer",
									__( "Line", "adamas-vc-shortcodes" )                 => "line_only",
									__( "Icon", "adamas-vc-shortcodes" )                 => "icon_only",
									__( "Image", "adamas-vc-shortcodes" )                => "image_only",
									__( "Line with icon/image", "adamas-vc-shortcodes" ) => "line_with_icon",
								),
								"description" => __( "Horizontal line, icon or image to divide sections", "adamas-vc-shortcodes" ),
							),
							array(
								"type"       => "dropdown",
								"class"      => "",
								"heading"    => __( "Separator Position", "adamas-vc-shortcodes" ),
								"param_name" => "spacer_position",
								"value"      => array(
									__( "Top", "adamas-vc-shortcodes" )                           => "top",
									__( "Between Heading & Sub-Heading", "adamas-vc-shortcodes" ) => "middle",
									__( "Bottom", "adamas-vc-shortcodes" )                        => "bottom"
								),
								//"description" => __("Alignment of separator", "smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only", "icon_only", "image_only" ) ),
							),
							array(
								"type"       => "ult_img_single",
								"heading"    => __( "Select Image", "adamas-vc-shortcodes" ),
								"param_name" => "spacer_img",
								//"description" => __("Alignment of spacer", "smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "image_only" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Image Width", "adamas-vc-shortcodes" ),
								"param_name"  => "spacer_img_width",
								"value"       => 48,
								"suffix"      => "px",
								"description" => __( "Provide image width (optional)", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "spacer", "value" => array( "image_only" ) ),
							),
							array(
								"type"       => "dropdown",
								"class"      => "",
								"heading"    => __( "Line Style", "adamas-vc-shortcodes" ),
								"param_name" => "line_style",
								"value"      => array(
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								//"description" => __("Select the line style.","smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only" ) ),
							),
							array(
								"type"       => "number",
								"class"      => "",
								"heading"    => __( "Line Width (optional)", "adamas-vc-shortcodes" ),
								"param_name" => "line_width",
								//"value" => 250,
								//"min" => 150,
								//"max" => 500,
								"suffix"     => "px",
								//"description" => __("Set line width", "smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only" ) ),
							),
							array(
								"type"       => "number",
								"class"      => "",
								"heading"    => __( "Line Height", "adamas-vc-shortcodes" ),
								"param_name" => "line_height",
								"value"      => 1,
								"min"        => 1,
								"max"        => 500,
								"suffix"     => "px",
								//"description" => __("Set line height", "smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only" ) ),
							),
							array(
								"type"       => "colorpicker",
								"class"      => "",
								"heading"    => __( "Line Color", "adamas-vc-shortcodes" ),
								"param_name" => "line_color",
								"value"      => "#333333",
								//"description" => __("Select color for line.", "smile"),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon to display:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_type",
								"value"       => array(
									__( "Font Icon Manager", "adamas-vc-shortcodes" ) => "selector",
									__( "Custom Image Icon", "adamas-vc-shortcodes" ) => "custom",
								),
								"description" => __( "Use an existing font icon or upload a custom image.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "spacer", "value" => array( "line_with_icon", "icon_only" ) ),
							),
							array(
								"type"        => "icon_manager",
								"class"       => "",
								"heading"     => __( "Select Icon ", "adamas-vc-shortcodes" ),
								"param_name"  => "icon",
								"value"       => "",
								"description" => __( "Click and select icon of your choice. If you can't find the one that suits for your purpose", "adamas-vc-shortcodes" ) . ", " . __( "you can", "adamas-vc-shortcodes" ) . " <a href='admin.php?page=bsf-font-icon-manager' target='_blank' rel='noopener'>" . __( "add new here", "adamas-vc-shortcodes" ) . "</a>.",
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Size of Icon", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_size",
								"value"       => 32,
								"min"         => 12,
								"max"         => 72,
								"suffix"      => "px",
								"description" => __( "How big would you like it?", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color",
								"value"       => "",
								"description" => __( "Give it a nice paint!", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_style",
								"value"       => array(
									__( "Simple", "adamas-vc-shortcodes" )            => "none",
									__( "Circle Background", "adamas-vc-shortcodes" ) => "circle",
									__( "Square Background", "adamas-vc-shortcodes" ) => "square",
									__( "Design your own", "adamas-vc-shortcodes" )   => "advanced",
								),
								"description" => __( "We have given three quick preset if you are in a hurry. Otherwise, create your own with various options.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "selector" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Background Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_bg",
								"value"       => "",
								"description" => __( "Select background color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "circle", "square", "advanced" ) ),
							),
							array(
								"type"        => "dropdown",
								"class"       => "",
								"heading"     => __( "Icon Border Style", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_style",
								"value"       => array(
									__( "None", "adamas-vc-shortcodes" )   => "",
									__( "Solid", "adamas-vc-shortcodes" )  => "solid",
									__( "Dashed", "adamas-vc-shortcodes" ) => "dashed",
									__( "Dotted", "adamas-vc-shortcodes" ) => "dotted",
									__( "Double", "adamas-vc-shortcodes" ) => "double",
									__( "Inset", "adamas-vc-shortcodes" )  => "inset",
									__( "Outset", "adamas-vc-shortcodes" ) => "outset",
								),
								"description" => __( "Select the border style for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							array(
								"type"        => "colorpicker",
								"class"       => "",
								"heading"     => __( "Border Color", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_color_border",
								"value"       => "#333333",
								"description" => __( "Select border color for icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Width", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_size",
								"value"       => 1,
								"min"         => 1,
								"max"         => 10,
								"suffix"      => "px",
								"description" => __( "Thickness of the border.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Border Radius", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_radius",
								"value"       => 500,
								"min"         => 1,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "0 pixel value will create a square border. As you increase the value, the shape convert in circle slowly. (e.g 500 pixels).", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_border_style", "not_empty" => true ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Background Size", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_border_spacing",
								"value"       => 50,
								"min"         => 30,
								"max"         => 500,
								"suffix"      => "px",
								"description" => __( "Spacing from center of the icon till the boundary of border / background", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_style", "value" => array( "advanced" ) ),
							),
							array(
								"type"        => "ult_img_single",
								"class"       => "",
								"heading"     => __( "Upload Image Icon:", "adamas-vc-shortcodes" ),
								"param_name"  => "icon_img",
								"value"       => "",
								"description" => __( "Upload the custom image icon.", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"        => "number",
								"class"       => "",
								"heading"     => __( "Image Width", "adamas-vc-shortcodes" ),
								"param_name"  => "img_width",
								"value"       => 48,
								"min"         => 16,
								"max"         => 512,
								"suffix"      => "px",
								"description" => __( "Provide image width", "adamas-vc-shortcodes" ),
								"dependency"  => Array( "element" => "icon_type", "value" => array( "custom" ) ),
							),
							array(
								"type"       => "ultimate_margins",
								"heading"    => "Separator Margins",
								"param_name" => "spacer_margin",
								"positions"  => array(
									__( "Top", "adamas-vc-shortcodes" )    => "top",
									__( "Bottom", "adamas-vc-shortcodes" ) => "bottom"
								),
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon", "line_only", "icon_only", "image_only" ) ),
								"group"      => "Design"
							),
							array(
								"type"       => "number",
								"heading"    => __( "Space between Line & Icon/Image", "adamas-vc-shortcodes" ),
								"param_name" => "line_icon_fixer",
								"value"      => "10",
								"suffix"     => "px",
								"dependency" => Array( "element" => "spacer", "value" => array( "line_with_icon" ) ),
							),
							array(
								'type'        => 'attach_image',
								'heading'     => __( 'Background image', 'adamas-vc-shortcodes' ),
								'param_name'  => 'bg_image',
								'description' => ''
							),
							array(
								'type'        => 'colorpicker',
								'heading'     => __( 'Background overlay color', 'adamas-vc-shortcodes' ),
								'param_name'  => 'bg_overlay',
								'description' => ''
							),
							// Animation
							array(
								'type'        => 'dropdown',
								'class'       => '',
								'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
								'param_name'  => 'module_animation',
								'value'       => st_adamas_animations_list(),
								'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
							),
							array(
								"type"        => "textfield",
								"heading"     => __( "Extra class name", "adamas-vc-shortcodes" ),
								"param_name"  => "el_class",
								"description" => __( "If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", "adamas-vc-shortcodes" )
							),
							array(
								"type"             => "ult_param_heading",
								"text"             => "<span style='display: block;'><a href='http://bsf.io/8v9sy' target='_blank' rel='noopener'>" . __( "Watch Video Tutorial", "adamas-vc-shortcodes" ) . " &nbsp; <span class='dashicons dashicons-video-alt3' style='font-size:30px;vertical-align: middle;color: #e52d27;'></span></a></span>",
								"param_name"       => "notification",
								'edit_field_class' => 'ult-param-important-wrapper ult-dashicon ult-align-right ult-bold-font ult-blue-font vc_column vc_col-sm-12',
							),
						)
					)
				);
			}
		}

		function ultimate_headings_shortcode( $atts, $content = null ) {
			$wrapper_style       = $main_heading_style_inline = $sub_heading_style_inline = $line_style_inline = $icon_inline = $output = $el_class = '';
			$enable_heading_elem = $heading_elem_bg_check = $heading_elem_color = $bg_img = $overlay = $elem_style = $elem_type = $elem_bottom_height = $main_heading_letter_spacing = $sub_heading_letter_spacing = $module_animation = $animation = $animated = '';
			extract( shortcode_atts( array(
				'source'                   => "",
				'main_heading'             => "",
				"main_heading_font_size"   => "",
				"main_heading_line_height" => "",
				"main_heading_font_family" => "",
				"main_heading_style"       => "",
				"main_heading_color"       => "",
				"main_heading_margin"      => "",
				"sub_heading"              => "",
				"sub_heading_font_size"    => "",
				"sub_heading_line_height"  => "",
				"sub_heading_font_family"  => "",
				"sub_heading_style"        => "",
				"sub_heading_color"        => "",
				"sub_heading_margin"       => "",
				"spacer"                   => "no_spacer",
				"spacer_position"          => "top",
				"spacer_img"               => "",
				"spacer_img_width"         => "",
				"line_style"               => "solid",
				"line_width"               => "auto",
				"line_height"              => "1",
				"line_color"               => "#ccc",
				"icon_type"                => "selector",
				"icon"                     => "",
				"icon_color"               => "",
				"icon_style"               => "none",
				"icon_color_bg"            => "",
				"icon_border_style"        => "",
				"icon_color_border"        => "#333333",
				"icon_border_size"         => "1",
				"icon_border_radius"       => "",
				"icon_border_spacing"      => "",
				"icon_img"                 => "",
				"img_width"                => "48",
				"icon_size"                => "32",
				"alignment"                => "center",
				"spacer_margin"            => "top",
				"line_icon_fixer"          => "10",
				"heading_tag"              => "",
				"bg_image"                 => "",
				"bg_overlay"               => "",
				"enable_heading_elem"      => "",
				"heading_elem_bg_check"    => "",
				"heading_elem_color"       => "",
				"elem_type"                => "",
				"elem_bottom_height"       => "",
				"elem_top_height"          => "",
				"module_animation"         => "",
				"el_class"                 => "",
			), $atts ) );
			$vc_version    = ( defined( 'WPB_VC_VERSION' ) ) ? WPB_VC_VERSION : 0;
			$is_vc_49_plus = ( version_compare( 4.9, $vc_version, '<=' ) ) ? 'ult-adjust-bottom-margin' : '';
			$wrapper_class = $spacer;

			if ( $heading_tag == '' ) {
				$heading_tag = 'h2';
			}

			if ( $source == 'post_title' ) {
				global $post;
				$main_heading = $post->post_title;
			}

			if ( $elem_type == '' ) {
				$elem_type = 'gradient';
			}

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			/* ---- main heading styles ---- */
			if ( $main_heading_font_family != '' ) {
				$mhfont_family = get_ultimate_font_family( $main_heading_font_family );
				if ( $mhfont_family ) {
					$main_heading_style_inline .= 'font-family:\'' . $mhfont_family . '\';';
				}
			}
			// main heading font style
			$main_heading_style_inline .= get_ultimate_font_style( $main_heading_style );
			//attach font size if set

			//attach font color if set
			if ( $main_heading_color != '' ) {
				$main_heading_style_inline .= 'color:' . $main_heading_color . ';';
			}
			//attach margins for main heading
			if ( $main_heading_margin != '' ) {
				$main_heading_style_inline .= $main_heading_margin;
			}

			/* ----- sub heading styles ----- */
			if ( $sub_heading_font_family != '' ) {
				$shfont_family = get_ultimate_font_family( $sub_heading_font_family );
				if ( $shfont_family != '' ) {
					$sub_heading_style_inline .= 'font-family:\'' . $shfont_family . '\';';
				}
			}
			//sub heaing font style
			$sub_heading_style_inline .= get_ultimate_font_style( $sub_heading_style );

			//attach font color if set
			if ( $sub_heading_color != '' ) {
				$sub_heading_style_inline .= 'color:' . $sub_heading_color . ';';
			}
			//attach margins for sub heading
			if ( $sub_heading_margin != '' ) {
				$sub_heading_style_inline .= $sub_heading_margin;
			}

			if ( $spacer != '' ) {
				$wrapper_style .= $spacer_margin;
			}
			if ( $spacer == 'line_with_icon' ) {
				if ( $line_width < $icon_size ) {
					$wrap_width = $icon_size;
				} else {
					$wrap_width = $line_width;
				}
				if ( $icon_type == 'selector' ) {
					if ( $icon_style == 'advanced' ) {
						//if($icon_border_spacing != '')
						//$wrapper_style .= 'padding:'.$icon_border_spacing.'px 0;';
					} else {
						$wrapper_style .= 'height:' . $icon_size . 'px;';
					}
				}
				$icon_style_inline = 'font-size:' . $icon_size . 'px;';
			} else if ( $spacer == 'line_only' ) {
				$wrap_width        = $line_width;
				$line_style_inline = 'border-style:' . $line_style . ';';
				$line_style_inline .= 'border-bottom-width:' . $line_height . 'px;';
				$line_style_inline .= 'border-color:' . $line_color . ';';
				$line_style_inline .= 'width:' . $wrap_width . 'px;';
				$wrapper_style     .= 'height:' . $line_height . 'px;';
				$line              = '<span class="uvc-headings-line" style="' . esc_attr( $line_style_inline ) . '"></span>';
				$icon_inline       = $line;
			} else if ( $spacer == 'icon_only' ) {
				$icon_style_inline = 'font-size:' . $icon_size . 'px;';
			} else if ( $spacer == 'image_only' ) {
				if ( ! empty( $spacer_img_width ) ) {
					$siwidth = array( $spacer_img_width, $spacer_img_width );
				} else {
					$siwidth = 'full';
				}

				$spacer_inline = '';
				//$icon_inline = wp_get_attachment_image( $spacer_img, $siwidth, false, array("class"=>"ultimate-headings-icon-image") );
				$icon_inline = apply_filters( 'ult_get_img_single', $spacer_img, 'url' );
				$alt         = apply_filters( 'ult_get_img_single', $spacer_img, 'alt' );
				if ( $spacer_img_width !== '' ) {
					$spacer_inline = 'width:' . $spacer_img_width . 'px';
				}
				$icon_inline = '<img src="' . esc_url( apply_filters( 'ultimate_images', $icon_inline ) ) . '" class="ultimate-headings-icon-image" alt="' . esc_attr( $alt ) . '" style="' . esc_attr( $spacer_inline ) . '"/>';
			}
			//if spacer type is line with icon or only icon show icon or image respectively
			if ( $spacer == 'line_with_icon' || $spacer == 'icon_only' ) {
				$icon_animation = '';
				$icon_inline    = do_shortcode( '[just_icon icon_align="' . esc_attr( $alignment ) . '" icon_type="' . esc_attr( $icon_type ) . '" icon="' . esc_attr( $icon ) . '" icon_img="' . esc_attr( $icon_img ) . '" img_width="' . esc_attr( $img_width ) . '" icon_size="' . esc_attr( $icon_size ) . '" icon_color="' . esc_attr( $icon_color ) . '" icon_style="' . esc_attr( $icon_style ) . '" icon_color_bg="' . esc_attr( $icon_color_bg ) . '" icon_color_border="' . esc_attr( $icon_color_border ) . '"  icon_border_style="' . esc_attr( $icon_border_style ) . '" icon_border_size="' . esc_attr( $icon_border_size ) . '" icon_border_radius="' . esc_attr( $icon_border_radius ) . '" icon_border_spacing="' . esc_attr( $icon_border_spacing ) . '" icon_animation="' . esc_attr( $icon_animation ) . '"]' );
			}
			if ( $spacer == 'line_with_icon' ) {
				$data = 'data-hline_width="' . esc_attr( $wrap_width ) . '" data-hicon_type="' . esc_attr( $icon_type ) . '" data-hborder_style="' . esc_attr( $line_style ) . '" data-hborder_height="' . esc_attr( $line_height ) . '" data-hborder_color="' . esc_attr( $line_color ) . '"';
				if ( $icon_type == 'selector' ) {
					$data .= ' data-icon_width="' . esc_attr( $icon_size ) . '"';
				} else {
					$data .= ' data-icon_width="' . esc_attr( $img_width ) . '"';
				}
				if ( $line_icon_fixer != '' ) {
					$data .= ' data-hfixer="' . esc_attr( $line_icon_fixer ) . '" ';
				}
			} else {
				$data = '';
			}
			$micro = rand( 0000, 9999 );
			$id    = uniqid( 'ultimate-heading-' . $micro );
			$uid   = 'uvc-' . rand( 0000, 9999 );

			// FIX: set old font size before implementing responsive param
			if ( is_numeric( $main_heading_font_size ) ) {
				$main_heading_font_size = 'desktop:' . $main_heading_font_size . 'px;';
			}
			if ( is_numeric( $main_heading_line_height ) ) {
				$main_heading_line_height = 'desktop:' . $main_heading_line_height . 'px;';
			}
			// responsive {main} heading styles
			$args                    = array(
				'target'      => '.uvc-heading.' . $id . ' ' . $heading_tag,
				'media_sizes' => array(
					'font-size'   => $main_heading_font_size,
					'line-height' => $main_heading_line_height,
				),
			);
			$main_heading_responsive = get_ultimate_vc_responsive_media_css( $args );

			// FIX: set old font size before implementing responsive param
			if ( is_numeric( $sub_heading_font_size ) ) {
				$sub_heading_font_size = 'desktop:' . $sub_heading_font_size . 'px;';
			}
			if ( is_numeric( $sub_heading_line_height ) ) {
				$sub_heading_line_height = 'desktop:' . $sub_heading_line_height . 'px;';
			}
			// responsive {sub} heading styles
			$args                   = array(
				'target'      => '.uvc-heading.' . $id . ' .uvc-sub-heading ',
				'media_sizes' => array(
					'font-size'   => $sub_heading_font_size,
					'line-height' => $sub_heading_line_height,
				),
			);
			$sub_heading_responsive = get_ultimate_vc_responsive_media_css( $args );

			if ( $enable_heading_elem ) {
				$el_class .= ' enable-elem';
			}
			if ( $heading_elem_bg_check ) {
				$el_class .= ' elem-dark-bg';
			}

			$img      = wp_get_attachment_image_src( $bg_image, 'full' );
			$img_link = $img[0];

			if ( $img ) {
				$bg_img   = 'background-image:url(' . $img_link . ');';
				$el_class .= ' uvc-heading-bg-image';
			}
			if ( $bg_overlay ) {
				$overlay = ' style="background:' . $bg_overlay . ';"';
			}
			if ( $enable_heading_elem && $elem_type == 'gradient' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				}
				$gradient = '<i class="st-h-before"><i ' . $elem_style . '></i><i ' . $elem_style . '></i><i ' . $elem_style . '></i><i ' . $elem_style . '></i></i>';
			} else {
				$gradient = '';
			}

			if ( $enable_heading_elem && $elem_type == 'side' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				}
				$side = '<i class="st-h-before"><i' . $elem_style . '></i></i>';
			} else {
				$side = '';
			}

			if ( $enable_heading_elem && $elem_type == 'bottom' ) {
				$bottom_style = ' style="';
				if ( $heading_elem_color ) {
					$bottom_style .= 'background-color:' . $heading_elem_color . ';';
				}
				if ( ! empty( $elem_bottom_height ) && is_numeric( $elem_bottom_height ) ) {
					$bottom_style .= 'height:' . $elem_bottom_height . 'px;';
				}
				$bottom_style .= '"';
				$bottom       = '<i class="st-h-after"><i' . $bottom_style . '></i></i>';
			} else {
				$bottom = '';
			}

			if ( $enable_heading_elem && $elem_type == 'top' ) {
				$top_style = ' style="';
				if ( $heading_elem_color ) {
					$top_style .= 'background-color:' . $heading_elem_color . ';';
				}
				if ( ! empty( $elem_top_height ) && is_numeric( $elem_top_height ) ) {
					$top_style .= 'height:' . $elem_top_height . 'px;';
				}
				$top_style .= '"';
				$top       = '<i class="st-h-before"><i' . $top_style . '></i></i>';
			} else {
				$top = '';
			}

			if ( $enable_heading_elem && $elem_type == 'square' ) {
				if ( $heading_elem_color ) {
					$elem_style   = ' style="background-color:' . $heading_elem_color . '"';
					$square_style = ' style="box-shadow: 0px 0px 0px 500px ' . $heading_elem_color . '"';
				} else {
					$elem_style   = '';
					$square_style = '';
				}
				$square       = '<i class="st-h-before"><i ' . $elem_style . '></i><i><i ' . $square_style . '></i></i></i>';
				$square_after = '<i class="st-h-after"><i ' . $elem_style . '><i></i></i></i>';
			} else {
				$square       = '';
				$square_after = '';
			}

			if ( $enable_heading_elem && $elem_type == 'square_2' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				} else {
					$elem_style   = '';
					$square_style = '';
				}
				$square_2 = '<i class="st-h-before"><i ' . $elem_style . '></i><i ' . $elem_style . '></i><i ' . $elem_style . '></i><i ' . $elem_style . '></i></i>';
			} else {
				$square_2 = '';
			}

			if ( $enable_heading_elem && $elem_type == 'square_3' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				} else {
					$elem_style   = '';
					$square_style = '';
				}
				$square_3 = '<i class="st-h-before"><i ' . $elem_style . '></i><i></i><i></i><i></i></i>';
			} else {
				$square_3 = '';
			}

			if ( $enable_heading_elem && $elem_type == 'circle' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				} else {
					$elem_style = '';
				}
				$circle = '<i class="st-h-before"><i ' . $elem_style . '></i></i>';
			} else {
				$circle = '';
			}

			if ( $enable_heading_elem && $elem_type == 'ring' ) {
				if ( $heading_elem_color ) {
					$elem_style = ' style="background-color:' . $heading_elem_color . '"';
				} else {
					$elem_style = '';
				}
				$ring = '<i class="st-h-before"><i ' . $elem_style . '></i></i>';
			} else {
				$ring = '';
			}

			$el_class .= ' ' . $elem_type . ' ' . $heading_tag;

			$output = '<div id="' . esc_attr( $id ) . '" class="uvc-heading ' . esc_attr( $is_vc_49_plus ) . ' ' . esc_attr( $id ) . ' ' . esc_attr( $uid ) . ' ' . esc_attr( $el_class ) . '" data-hspacer="' . esc_attr( $spacer ) . '" ' . $data . ' data-halign="' . esc_attr( $alignment ) . '" style="text-align:' . esc_attr( $alignment ) . ';' . $bg_img . '">';
			if ( $overlay ) {
				$output .= '<div class="st-uvc-heading-bg-overlay" ' . $overlay . '></div>';
			}
			if ( $alignment != 'center' ) {
				$output .= $side;
			}
			if ( $spacer_position == 'top' ) {
				$output .= $this->ultimate_heading_spacer( $wrapper_class, $wrapper_style, $icon_inline );
			}
			if ( $main_heading != '' ) {
				$output .= '<div class="uvc-main-heading ult-responsive" ' . $main_heading_responsive . '><' . $heading_tag . ' style="' . esc_attr( $main_heading_style_inline ) . '">' . $top . $circle . $ring . $square . $square_2 . $square_3 . $gradient . $main_heading . $square_after . '</' . $heading_tag . '></div>';
			}
			if ( $spacer_position == 'middle' ) {
				$output .= $this->ultimate_heading_spacer( $wrapper_class, $wrapper_style, $icon_inline );
			}
			if ( $content != '' ) {
				$output .= '<div class="uvc-sub-heading ult-responsive" ' . $sub_heading_responsive . ' style="' . esc_attr( $sub_heading_style_inline ) . '">' . do_shortcode( $content ) . '</div>';
			}
			$output .= $bottom;
			if ( $spacer_position == 'bottom' ) {
				$output .= $this->ultimate_heading_spacer( $wrapper_class, $wrapper_style, $icon_inline );
			}
			$output .= '</div>';

			$is_preset = false; //Display settings for Preset
			if ( isset( $_GET['preset'] ) ) {
				$is_preset = true;
			}
			if ( $is_preset ) {
				$text = 'array ( ';
				foreach ( $atts as $key => $att ) {
					$text .= '<br/>	\'' . $key . '\' => \'' . $att . '\',';
				}
				if ( $content != '' ) {
					$text .= '<br/>	\'content\' => \'' . $content . '\',';
				}
				$text   .= '<br/>)';
				$output .= '<pre>';
				$output .= $text;
				$output .= '</pre>';
			}

			return $output;
		}

		function ultimate_heading_spacer( $wrapper_class, $wrapper_style, $icon_inline ) {
			$spacer = '<div class="uvc-heading-spacer ' . $wrapper_class . '" style="' . $wrapper_style . '">' . $icon_inline . '</div>';

			return $spacer;
		}
	} // end class
	new Ultimate_Headings;
	if ( class_exists( 'WPBakeryShortCode' ) && ! class_exists( 'WPBakeryShortCode_ultimate_heading' ) ) {
		class WPBakeryShortCode_ultimate_heading extends WPBakeryShortCode {
		}
	}
}