<?php

$el_class = $module_animation = $animation = $animated = '';
$output   = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'module_animation' => '',
	'el_class'         => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

$previous_post = get_previous_post();
if ( $previous_post ) {
	$previous_post_type     = get_post_type( $previous_post->ID );
	$previous_link          = get_permalink( $previous_post->ID );
	$previous_thumbnail     = wp_get_attachment_url( get_post_thumbnail_id( $previous_post->ID ), 'full' );
	$previous_thumbnail_url = st_adamas_aq_resize( $previous_thumbnail, 85, 85, true, true, true );
	if ( $previous_post_type == 'projects' ) {
		$previous_post_categories = wp_get_post_terms( $previous_post->ID, 'project_category' );
		if ( ! empty( $previous_post_categories ) && is_array( $previous_post_categories ) && ! is_wp_error( $previous_post_categories ) ) {
			$previous_post_category_name = $previous_post_categories[0]->name;
		}
	} else {
		$previous_post_categories    = get_the_category( $previous_post->ID );
		$previous_post_category_name = $previous_post_categories[0]->name;
	}
}

$next_post = get_next_post();
if ( $next_post ) {
	$next_post_type     = get_post_type( $next_post->ID );
	$next_link          = get_permalink( $next_post->ID );
	$next_thumbnail     = wp_get_attachment_url( get_post_thumbnail_id( $next_post->ID ), 'full' );
	$next_thumbnail_url = st_adamas_aq_resize( $next_thumbnail, 150, 150, true, true, true );
	if ( $next_post_type == 'projects' ) {
		$next_post_categories = wp_get_post_terms( $next_post->ID, 'project_category' );
		if ( ! empty( $next_post_categories ) && is_array( $next_post_categories ) && ! is_wp_error( $next_post_categories ) ) {
			$next_post_category_name = $next_post_categories[0]->name;
		}
	} else {
		$next_post_categories    = get_the_category( $next_post->ID );
		$next_post_category_name = $next_post_categories[0]->name;
	}
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-pagination-block ' . esc_attr( $css_class ) . '">';
if ( get_previous_post() ) {
	$output .= '<div class="st-pagination-block-previous">';
	$output .= '<a href="' . esc_url( $previous_link ) . '"><div class="st-pagination-block-post-thumbnail" style="background-image:url(' . esc_url( $previous_thumbnail_url ) . ')"><div class="st-pagination-block-post-thumbnail-inner"><i class="fa fa-angle-left" aria-hidden="true"></i></div></div></a>';
	$output .= '<div class="st-pagination-block-inner">';
	$output .= '<div class="st-pagination-block-post-title"><a href="' . esc_url( $previous_link ) . '">' . esc_attr( $previous_post->post_title ) . '</a></div>';
	$output .= '<div class="st-pagination-block-post-category">' . esc_attr( $previous_post_category_name ) . '</div>';
	$output .= '</div>'; // st-pagination-block-inner
	$output .= '</div>'; // st-pagination-block-previous
}
$output .= '<div class="st-pagination-block-separator"></div>';
if ( get_next_post() ) {
	$output .= '<div class="st-pagination-block-next">';
	$output .= '<a href="' . esc_url( $next_link ) . '"><div class="st-pagination-block-post-thumbnail" style="background-image:url(' . esc_url( $next_thumbnail_url ) . ')"><div class="st-pagination-block-post-thumbnail-inner"><i class="fa fa-angle-right" aria-hidden="true"></i></div></div></a>';
	$output .= '<div class="st-pagination-block-inner">';
	$output .= '<div class="st-pagination-block-post-title"><a href="' . esc_url( $next_link ) . '">' . esc_attr( $next_post->post_title ) . '</a></div>';
	$output .= '<div class="st-pagination-block-post-category">' . esc_attr( $next_post_category_name ) . '</div>';
	$output .= '</div>'; // st-pagination-block-inner
	$output .= '</div>'; // st-pagination-block-next
}
$output .= '</div>'; // st-pagination-block

echo $output;