<?php
/**
 * The template for the menu container of the panel.
 * Override this template by specifying the path where it is stored (templates_path) in your Redux config.
 *
 * @author     Redux Framework
 * @package    ReduxFramework/Templates
 * @version:    4.0.0
 */

?>
<div class="redux-sidebar">
    <ul class="redux-group-menu">
		<?php
		foreach ( $this->parent->sections as $k => $section ) {
			$the_title = isset( $section['title'] ) ? $section['title'] : '';
			$skip_sec  = false;
			foreach ( $this->parent->options_class->hidden_perm_sections as $num => $section_title ) {
				if ( $section_title === $the_title ) {
					$skip_sec = true;
				}
			}

			if ( isset( $section['customizer_only'] ) && true === $section['customizer_only'] ) {
				continue;
			}

			if ( false === $skip_sec ) {
				$allowed_html = array(
					'a'       => array(
						'id'       => array(),
						'class'    => array(),
						'data-key' => array(),
						'data-rel' => array(),
						'style'    => array(),
					),
					'i'       => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'img'     => array(
						'class' => array(),
						'src'   => array(),
					),
					'span'    => array(
						'class' => array()
					),
					'div'     => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'ul'      => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'li'      => array(
						'id'       => array(),
						'class'    => array(),
						'data-key' => array(),
						'data-rel' => array(),
						'style'    => array(),
					),
					'input'   => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
						'value' => array(),
						'type'  => array()
					),
					'section' => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'h1'      => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'h2'      => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
					'h3'      => array(
						'id'    => array(),
						'class' => array(),
						'style' => array(),
					),
				);

				echo( wp_kses( $this->parent->section_menu( $k, $section ), $allowed_html ) ); // phpcs:ignore WordPress.Security.EscapeOutput
				$skip_sec = false;
			}
		}

		/**
		 * Action 'redux/page/{opt_name}/menu/after'
		 *
		 * @param object $this ReduxFramework
		 */
		do_action( "redux/page/{$this->parent->args['opt_name']}/menu/after", $this ); // phpcs:ignore WordPress.NamingConventions.ValidHookName
		?>
    </ul>
</div>
