/**
 * Tribe Image Widget Javascript
 * @author Modern Tribe, Inc.
 * Copyright 2013.
 */
jQuery(document).ready(function ($) {

    BannerWidget = {

        // Call this from the upload button to initiate the upload frame.
        uploader: function (widget_id, widget_id_string) {

            var frame = wp.media({
                title: BannerWidget.frame_title,
                multiple: false,
                library: {type: 'image'},
                button: {text: BannerWidget.button_title}
            });

            // Handle results from media manager.
            frame.on('close', function () {
                var attachments = frame.state().get('selection').toJSON();
                BannerWidget.render(widget_id, widget_id_string, attachments[0]);
            });

            frame.open();
            return false;
        },

        // Output Image preview and populate widget form.
        render: function (widget_id, widget_id_string, attachment) {

            $("#" + widget_id_string + 'preview').html(BannerWidget.imgHTML(attachment));

            $("#" + widget_id_string + 'fields').slideDown();

            $("#" + widget_id_string + 'imageurl').val(attachment.url);

            BannerWidget.updateInputIfEmpty(widget_id_string, 'title', attachment.title);
            BannerWidget.updateInputIfEmpty(widget_id_string, 'alt', attachment.alt);
        },

        // Update input fields if it is empty
        updateInputIfEmpty: function (widget_id_string, name, value) {
            var field = $("#" + widget_id_string + name);
            if (field.val() == '') {
                field.val(value);
            }
        },

        // Render html for the image.
        imgHTML: function (attachment) {
            var img_html = '<img src="' + attachment.url + '" ';
            img_html += 'width="' + attachment.width + '" ';
            img_html += 'height="' + attachment.height + '" ';
            if (attachment.alt != '') {
                img_html += 'alt="' + attachment.alt + '" ';
            }
            img_html += '/>';
            return img_html;
        }

    };

});