// New Charts
(function ($) {
    "use strict";
    var waypoint = "undefined" != typeof $.fn.waypoint;
    var $this = $('.vc_chart');
    Chart.defaults.global.defaultFontFamily = $this.data('font');
    Chart.defaults.global.defaultFontSize = 14;

    $this.each(function () {
        var $this = $(this);
        var ctx = $this.find('canvas');
        var legend, pos, tooltips;

        $this.waypoint(function () {
            if ($this.data('vcTooltips') === 1) {
                tooltips = true;
            } else {
                tooltips = false;
            }
            if ($this.hasClass('display-legend') && $this.hasClass('st-legend-bottom')) {
                legend = true;
                pos = 'bottom';
            } else if ($this.hasClass('display-legend') && $this.hasClass('st-legend-right')) {
                legend = true;
                pos = 'right';
            } else {
                legend = false;
            }
            if ($this.data('vcType') === 'bar' || $this.data('vcType') === 'line' || $this.data('vcType') === 'radar') {
                new Chart(ctx, {
                    type: $this.data('vcType'),
                    data: $this.data('vcValues'),
                    options: {
                        legend: {
                            display: legend,
                            position: pos,
                            labels: {
                                boxWidth: 20,
                                fontColor: '#999999',
                                fontStyle: 'italic',
                                padding: 20,
                            },
                        },
                        tooltips: {
                            enabled: tooltips,
                        },
                        scales: {
                            yAxes: [{
                                ticks: {
                                    beginAtZero: true,
                                    fontSize: 12,
                                }
                            }]
                        },
                    }
                });
            } else if ($this.data('vcType') === 'doughnut' || $this.data('vcType') === 'pie' || $this.data('vcType') === 'polarArea') {
                new Chart(ctx, {
                    type: $this.data('vcType'),
                    data: $this.data('vcValues'),
                    options: {
                        legend: {
                            display: legend,
                            position: pos,
                            labels: {
                                boxWidth: 20,
                                fontColor: '#999999',
                                fontStyle: 'italic',
                                padding: 20,
                            },
                        },
                        tooltips: {
                            enabled: tooltips,
                        },
                    }
                });
            }

            try {
                this.destroy();
            } catch (e) {
                $.noop();
            }

        }, {
            offset: '90%',
            triggerOnce: true
        });
    });

})(jQuery);