<?php
/*
 * Additional functions and framework parameters
 */

// Multisite Option
function st_adamas_multisite() {
	$st_multisite_files = '';
	if ( is_multisite() ) {
		$blog_details = get_blog_details();
		$blog_id      = '';
		if ( ! empty( $blog_details ) && is_object( $blog_details ) ) {
			$st_multisite_files .= '-' . $blog_details->blog_id;
		}
	}

	return $st_multisite_files;
}

// Saving Theme Options
function st_adamas_saving_theme_options() {
	WP_Filesystem();
	global $wp_filesystem;

	$st_multisite = st_adamas_multisite();

	ob_start();
	require get_template_directory() . '/assets/theme_options.php';
	$theme_options = ob_get_clean();

	$theme_options_generated = get_template_directory() . '/assets/less/theme_options.less';

	$wp_filesystem->put_contents( $theme_options_generated, $theme_options );

	if ( ! class_exists( 'lessc' ) ) {
		require_once( get_template_directory() . '/includes/lib/lessc.inc.php' );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/main.less', get_template_directory() . '/assets/css/main' . $st_multisite . '.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/composer.less', get_template_directory() . '/assets/css/composer' . $st_multisite . '.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/woocommerce.less', get_template_directory() . '/assets/css/woocommerce' . $st_multisite . '.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/responsive.less', get_template_directory() . '/assets/css/responsive' . $st_multisite . '.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/compare.less', get_template_directory() . '/woocommerce/compare' . $st_multisite . '.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/rtl.less', get_template_directory() . '/assets/css/rtl.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

	try {
		$less = new lessc();
		$less->setFormatter( 'classic' );
		$less->compileFile( get_template_directory() . '/assets/less/editor-style.less', get_template_directory() . '/assets/css/editor-style.css' );
		unset ( $less );
	} catch ( Exception $ex ) {
		set_transient( 'redux-opts-exceptions-' . ST_ADAMAS_THEME_NAME, array( 'Less compile error: ' . $ex->getMessage() ), 1000 );
	}

}

add_action( 'customize_save_after', 'st_adamas_saving_theme_options' );
add_action( 'redux/options/' . ST_ADAMAS_THEME_NAME . '/saved', 'st_adamas_saving_theme_options' );
add_action( 'after_switch_theme', 'st_adamas_saving_theme_options' );

function st_adamas_customizer_styles() { ?>
    <style>
        #customize-controls .description {
            display: block;
        }

        #customize-theme-controls .control-section#accordion-section-color_setup {
            display: none !important;
        }
    </style>
	<?php

}

add_action( 'customize_controls_print_styles', 'st_adamas_customizer_styles', 999 );