<?php
global $st_adamas;
?>
<div class="topbar">
    <div class="row st-content-middle row-flex">
        <div class="st-12 st-desktop-9 col">
			<?php
			$departments_count = isset( $st_adamas['contact_department'] ) && $st_adamas['contact_department'] ? count( $st_adamas['contact_department'] ) : 0;
			if ( $departments_count === 0 || ( $departments_count > 0 && $st_adamas['contact_department'][0] === '' ) ) {
				$style = ' no-switcher';
			} else {
				$style = '';
			}
			?>
            <div class="topbar-info-wrapper<?php echo esc_attr( $style ); ?>">
				<?php for ( $i = 0; $i < $departments_count; $i ++ ) { ?>
                    <ul class="topbar-info" id="<?php echo esc_attr( $i ); ?>">
						<?php if ( ! empty( $st_adamas['contact_address'][ $i ] ) ) : ?>
                            <li>
                                <i class="fa fa-map-marker"></i>
                                <span><?php echo esc_html( $st_adamas['contact_address'][ $i ] ); ?></span>
                            </li>
						<?php endif; ?>
						<?php if ( ! empty( $st_adamas['contact_phone'][ $i ] ) ) : ?>
                            <li class="topbar-phone">
                                <i class="fa fa-phone"></i>
                                <span><?php echo esc_html( $st_adamas['contact_phone'][ $i ] ); ?></span>
                            </li>
						<?php endif; ?>
						<?php if ( ! empty( $st_adamas['contact_schedule'][ $i ] ) ) : ?>
                            <li>
                                <i class="fa fa-clock-o"></i>
                                <span><?php echo esc_html( $st_adamas['contact_schedule'][ $i ] ); ?></span>
                            </li>
						<?php endif; ?>
						<?php if ( ! empty( $st_adamas['contact_email'][ $i ] ) ) : ?>
                            <li>
                                <i class="fa fa-envelope"></i>
                                <a href="mailto:<?php echo sanitize_email( $st_adamas['contact_email'][ $i ] ); ?>">
                                    <span><?php echo esc_html( $st_adamas['contact_email'][ $i ] ); ?></span>
                                </a>
                            </li>
						<?php endif; ?>
                    </ul>
				<?php } ?>
            </div>
			<?php if ( $departments_count > 0 && $st_adamas['contact_department'][0] !== '' ) { ?>
                <div class="topbar-switcher <?php echo esc_attr( $departments_count === 1 ? 'no-select2' : '' ); ?>">
                    <select <?php echo esc_attr( $departments_count === 1 ? 'disabled' : '' ); ?>>
						<?php for ( $i = 0; $i < $departments_count; $i ++ ) { ?>
							<?php if ( isset( $st_adamas['contact_department'] ) ) : ?>
                                <option value="<?php echo esc_attr( $i ); ?>"><?php echo esc_html( $st_adamas['contact_department'][ $i ] ); ?></option>
							<?php endif; ?>
						<?php } ?>
                    </select>
                </div>
			<?php } ?>
        </div>
        <div class="st-12 st-desktop-3 col">
            <div class="topbar-social">
                <ul>
					<?php if ( ! empty( $st_adamas['socials_facebook'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_facebook'] ); ?>" target="_blank"><i class="fa fa-facebook"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_twitter'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_twitter'] ); ?>" target="_blank"><i class="fa fa-twitter"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_instagram'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_instagram'] ); ?>" target="_blank"><i class="fa fa-instagram"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_linkedin'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_linkedin'] ); ?>" target="_blank"><i class="fa fa-linkedin"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_gplus'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_gplus'] ); ?>" target="_blank"><i class="fa fa-google-plus"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_pinterest'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_pinterest'] ); ?>" target="_blank"><i class="fa fa-pinterest-p"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_youtube'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_youtube'] ); ?>" target="_blank"><i class="fa fa-youtube-play"></i></a></li>
					<?php endif; ?>
					<?php if ( ! empty( $st_adamas['socials_vk'] ) ) : ?>
                        <li><a href="<?php echo esc_url( $st_adamas['socials_vk'] ); ?>" target="_blank"><i class="fa fa-vk"></i></a></li>
					<?php endif; ?>
                </ul>
            </div>
			<?php
			if ( is_active_sidebar( 'wpml-switcher' ) ) {
				dynamic_sidebar( 'wpml-switcher' );
			}
			?>
        </div>
    </div>
</div>