<?php
global $st_adamas;

$current_post_sidebar = get_post_meta( $post->ID, 'st_single_post_sidebar', true );
if ( ! empty( $current_post_sidebar ) && $current_post_sidebar !== 'default' ) {
	$post_sidebar = $current_post_sidebar;
} elseif ( isset( $st_adamas['single_post_sidebar'] ) ) {
	$post_sidebar = isset( $st_adamas['single_post_sidebar'] ) ? $st_adamas['single_post_sidebar'] : 'right';
}

$single_post_sharing = $st_adamas['single_post_sharing']['enabled'];
$shares              = array();

foreach ( $single_post_sharing as $share_key => $share_value ) {
	if ( $share_key == 'placebo' ) {
		continue;
	}
	$shares[] = $share_key;
}

$shares = array_reverse( $shares );

?>
<?php if ( $post_sidebar == 'left' || $post_sidebar == 'both' ) {
	get_template_part( 'templates/sidebar/sidebar', 'left' );
} ?>
<?php if ( $post_sidebar == 'left' || $post_sidebar == 'right' ) { ?>
    <article <?php post_class( 'st-12 st-desktop-9 col' ); ?>>
<?php } elseif ( $post_sidebar == 'both' ) { ?>
    <article <?php post_class( 'st-12 st-desktop-6 col' ); ?>>
<?php } elseif ( $post_sidebar == 'none' ) { ?>
    <article <?php post_class( 'st-12 col' ); ?>>
<?php } ?>
    <div class="post-meta">
		<?php if ( ! is_attachment() ) { ?>
            <div class="post-category">
				<?php
				$categories = get_the_category();
				$output     = '';
				if ( ! empty( $categories ) ) {
					foreach ( $categories as $category ) {
						$output .= '<div class="post-category-single"><a href="' . esc_url( get_category_link( $category->term_id ) ) . '" title="' . sprintf( esc_attr( 'View all posts in %s', 'adamas' ), $category->name ) . '">' . esc_html( $category->name ) . '</a></div>';
					}
					echo trim( $output );
				}
				?>
            </div>
		<?php } ?>
        <time class="post-time" datetime="<?php echo get_the_date( 'Y-m-d' ); ?>">
			<?php echo get_the_date( get_option( 'date_format' ) ); ?>
        </time>
        <div class="post-author">
            <span><?php esc_html_e( 'Posted by', 'adamas' ) ?>:</span> <?php if ( get_the_author_meta( 'display_name', $post->post_author ) != '0' ) { ?>
                <span><?php echo get_the_author_meta( 'display_name', $post->post_author ); ?></span>
			<?php } else { ?>
                <span><?php echo get_the_author(); ?></span>
			<?php } ?>
        </div>
        <div class="post-comments-amount">
            <span><?php esc_html_e( 'Comments', 'adamas' ) ?>:</span>
            <span><?php comments_number( '0', '1', '%' ); ?></span>
        </div>
        <div class="post-likes-amount">
            <span><?php esc_html_e( 'Likes', 'adamas' ) ?>:</span>
            <span><?php echo st_adamas_get_simple_likes_count( get_the_ID() ); ?></span>
        </div>
        <div class="post-tags">
			<?php
			$tags = get_the_tags( get_the_ID() );
			if ( ! empty( $tags ) ) { ?>
				<?php
				$tags_output = '';
				foreach ( $tags as $tag ) {
					$tag_link    = get_tag_link( $tag->term_id );
					$tags_output .= '<a href="' . esc_url( $tag_link ) . '" title="' . esc_attr( $tag->name ) . ' tag" class="post-tag ' . esc_attr( $tag->slug ) . '">';
					$tags_output .= esc_html( $tag->name ) . '</a>';
				}
				echo wp_kses( $tags_output, array( 'a' => array( 'href' => array(), 'title' => array(), 'class' => array() ) ) );
				?>
			<?php } ?>
        </div>
    </div>

    <div class="post-content">
		<?php
		if ( ! get_post_format() ) {
			get_template_part( $post->ID, 'standard' );
			the_content();
		} elseif ( has_post_format( 'gallery' ) ) {
			get_template_part( 'templates/single/post', 'gallery' );
			the_content();
		} elseif ( has_post_format( 'video' ) ) {
			get_template_part( 'templates/single/post', 'video' );
			the_content();
		} elseif ( has_post_format( 'quote' ) ) {
			get_template_part( 'templates/single/post', 'quote' );
		} elseif ( has_post_format( 'audio' ) ) {
			get_template_part( 'templates/single/post', 'audio' );
			the_content();
		}
		?>
    </div>
<?php st_adamas_link_pages(); ?>
    <div class="post-likes">
		<?php echo st_adamas_get_simple_likes_button( get_the_ID() ); ?>
    </div>
<?php if ( ! empty( $st_adamas['mailchimp_shortcode'] ) && class_exists( 'MC4WP_MailChimp' ) ) { ?>
    <div class="post-subscribe">
		<?php echo do_shortcode( $st_adamas['mailchimp_shortcode'] ); ?>
    </div>
<?php } ?>
    <div class="post-sharing">
        <div class="post-sharing-inner" data-link="<?php echo get_permalink(); ?>"
             data-shares-count="<?php echo esc_attr( count( $shares ) ); ?>"
             data-shares="<?php echo esc_attr( json_encode( $shares ) ); ?>"></div>
        <div class="share"><?php esc_html_e( 'Share', 'adamas' ); ?></div>
    </div>

<?php
$author_desc = get_the_author_meta( 'description', $post->post_author );
if ( ! empty( $author_desc ) ) {
	?>
    <div class="post-author">
        <h3 class="post-author-about"><i class="st-h-before"><i></i><i></i><i></i><i></i></i>
			<?php esc_html_e( 'About author', 'adamas' ) ?>
        </h3>
        <div class="post-author-avatar" style="background-image: url(<?php echo get_avatar_url( $post->post_author, array( 'size' => 200 ) ) ?>)"></div>
        <div class="post-author-name">
            <div class="post-author-name-inner"><?php echo get_the_author_meta( 'display_name', $post->post_author ); ?></div>
        </div>
        <div class="post-author-bio"><?php echo get_the_author_meta( 'description', $post->post_author ); ?></div>
    </div>
<?php } ?>

<?php if ( ! is_attachment() ) { ?>
	<?php
	$post_id    = get_the_ID();
	$cat_ids    = array();
	$categories = get_the_category( $post_id );
	if ( ! empty( $categories ) ) {
		foreach ( $categories as $category ) {
			$cat_ids[] = $category->term_id;
		}
	}
	$args        = array(
		'post_type'    => 'post',
		'post__not_in' => array( $post_id ),
		'category__in' => $cat_ids,
		'post_status'  => 'publish',
	);
	$posts_query = new WP_Query( $args );
	if ( $posts_query->have_posts() ) :
		?>
        <div class="post-related-posts">
            <h3 class="post-related-posts-heading"><i class="st-h-before"><i></i><i><i></i></i><i></i><i></i></i>
				<?php esc_html_e( 'Related posts', 'adamas' ); ?>
                <i class="st-h-after"><i></i></i></h3>
            <div class="post-related-posts-inner">
				<?php
				while ( $posts_query->have_posts() ) : $posts_query->the_post();

					if ( has_post_thumbnail() ) {
						$class     = '';
						$thumbnail = get_post_thumbnail_id();
						$image_url = wp_get_attachment_url( $thumbnail );
						$image     = st_adamas_aq_resize( $image_url, 400, 300, true, true, true );
					} else {
						$class = 'no-thumbnail';
						$image = null;
					}
					?>
                    <article class="post-related-post st-desktop-4 col <?php echo esc_attr( $class ); ?>">
						<?php if ( ! empty( $image ) ) { ?>
                            <a href="<?php the_permalink(); ?>">
                                <div class="post-related-post-thumbnail" style="background-image:url(<?php echo esc_url( $image ); ?>)">
                                    <div class="post-related-post-overlay">
                                        <div class="post-related-post-likes"><i class="fa fa-heart-o" aria-hidden="true"></i>
											<?php echo st_adamas_get_simple_likes_count( get_the_ID() ); ?>
                                        </div>
                                        <div class="post-related-post-comments-count">
                                            <i class="fa fa-comments-o" aria-hidden="true"></i>
                                            <span class="comments-count"><?php comments_number( '0', '1', '%' ); ?></span>
                                        </div>
                                        <div class="post-related-post-excerpt"><?php echo wp_trim_words( get_the_excerpt(), 15, '...' ); ?></div>
                                        <div class="overlay-inner-left"></div>
                                        <div class="overlay-inner-right"></div>
                                    </div>
                                </div>
                            </a>
						<?php } ?>
                        <a href="<?php the_permalink(); ?>">
                            <h4 class="post-related-post-title"><?php
								$title = get_the_title();
								if ( empty( $title ) ) {
									the_time( get_option( 'date_format' ) );
								} else {
									echo esc_html( $title );
								}
								?>
                            </h4>
                        </a>
                        <time class="post-related-post-date"
                              datetime="<?php echo get_the_date( 'Y-m-d' ); ?>"><?php echo get_the_date( get_option( 'date_format' ) ); ?></time>
                        <div class="post-related-post-author"><span><?php esc_html_e( 'Posted by', 'adamas' ) ?>: </span>
							<?php if ( get_the_author_meta( 'display_name', $post->post_author ) !== '' ) { ?>
                                <span><?php echo get_the_author_meta( 'display_name', $post->post_author ); ?></span>
							<?php } else { ?>
                                <span><?php echo get_the_author(); ?></span>
							<?php } ?>
                        </div>
                    </article>
				<?php
				endwhile; ?>
            </div>
        </div>
	<?php
	endif;
	wp_reset_postdata();
}
?>
<?php comments_template(); ?>

    </article>
<?php if ( $post_sidebar == 'right' || $post_sidebar == 'both' ) {
	get_template_part( 'templates/sidebar/sidebar', 'right' );
}